//
//  BerekeningToepassing.m
//  Gyproc
//
//  Created by Bert Carrein on 1/06/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "BerekeningToepassing.h"
#import "ProductInformatie.h"
#import "ProductenCategorie.h"
#import "Afmeting.h"
#import "ProductStartView.h"
#import "Brain.h"


@implementation BerekeningToepassing

@synthesize delegate, productToepassing;
@synthesize toepassingTitel, toepassingOmschrijving;
@synthesize btnNL, btnFR;
@synthesize selectText, pickerButton;
@synthesize scrollView;
@synthesize berekeningFoto;
@synthesize logoImage;

@synthesize categorieArray;

//Init: ProductToepassing en delegate meegeven
- (id)initWithProductToepassing:(ProductToepassing *)aProductToepassing andDelegate:(id<BerekeningsmoduleDelegate, LanguageDelegate>)aDelegate {
    self = [super init];
    if (self) {
        self.productToepassing = aProductToepassing;
        self.delegate = aDelegate;
    }
    return self;
}

//Aantallen uit benodigdheden aanvullen met types
- (void)setTextForLabel:(UILabel *)lbl withArray:(NSMutableArray *)arr withString:(NSString *)str withPlace:(int)place forLanguage:(NSString *)lang {
    for (Afmeting *afmeting in delegate.typeArray) {
        if ([afmeting.code isEqualToString:str]) {
            if ([lang isEqualToString:@"NL"]) {
                if ([[arr objectAtIndex:place] isEqualToString:@"1"])
                    lbl.text = [NSString stringWithFormat:@"%@ %@",[arr objectAtIndex:place],afmeting.descriptionEnkelvoudNL];
                else
                    lbl.text = [NSString stringWithFormat:@"%@ %@",[arr objectAtIndex:place],afmeting.descriptionNL];
            } else {
                if ([[arr objectAtIndex:place] isEqualToString:@"1"])
                    lbl.text = [NSString stringWithFormat:@"%@ %@",[arr objectAtIndex:place],afmeting.descriptionEnkelvoudNL];
                else
                    lbl.text = [NSString stringWithFormat:@"%@ %@",[arr objectAtIndex:place],afmeting.descriptionNL];
            }
        }
    }
}

//Benodigdheden weergeven
- (void)getBenodigdhedenForOrientation:(NSString *)orientation {
    for (UIView *view in [[scrollView.subviews copy] autorelease]) {
        if ([view isKindOfClass:[UIButton class]] || [view isKindOfClass:[UILabel class]]) {
            [view removeFromSuperview];
        }
    }
    
    int count = -1;
    int place = -1;
    for (NSString *str in productToepassing.pickerViewData) {
        count++;
        if ([str isEqualToString:currentPickerValue]) {
            place = count;
        }
    }
    
    int categorieen = 0;
    int teller = 0;
    float padding = 15;
    float width = scrollView.frame.size.width - 50;
    float height = 60;
    float categorieHeight = 35;
    ProductenCategorie *vorigeCategorie = nil;
    
    for (ProductInformatie *info in productToepassing.productInformaties) {
        if (info.product.productenCategorie != vorigeCategorie) {
            UILabel *categorieLabel = [[UILabel alloc] initWithFrame:CGRectMake(40, 10+teller*height+(teller+1)*padding+categorieen*categorieHeight, width, categorieHeight-10)];
            categorieLabel.font = [UIFont boldSystemFontOfSize:15];
            categorieLabel.textColor = [UIColor colorWithRed:0.14 green:0.13 blue:0.29 alpha:1];
            categorieLabel.backgroundColor = [UIColor clearColor];
            if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
                categorieLabel.text = info.product.productenCategorie.titelNL;
            } else {
                categorieLabel.text = info.product.productenCategorie.titelFR;
            }
            [scrollView addSubview:categorieLabel];
            [categorieLabel release];
            categorieen++;
        }
        vorigeCategorie = info.product.productenCategorie;
        
        UIButton *infoView = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
        infoView.frame = CGRectMake(25, 5+teller*height + (teller+1)*padding + categorieen*categorieHeight, width, height);
        if ([orientation isEqualToString:@"Portrait"]) {
            [infoView setBackgroundImage:[UIImage imageNamed:@"benodigdheden-bg-ns.png"] forState:UIControlStateNormal];
            [infoView setBackgroundImage:[UIImage imageNamed:@"benodigdheden-bg-sl.png"] forState:UIControlStateHighlighted];
        } else {
            [infoView setBackgroundImage:[UIImage imageNamed:@"benodigdheden-bg-ns-l.png"] forState:UIControlStateNormal];
            [infoView setBackgroundImage:[UIImage imageNamed:@"benodigdheden-bg-sl-l.png"] forState:UIControlStateHighlighted];
        }
        
        UILabel *titel;
        UILabel *eenheden;
        UILabel *hoeveelheden;
        
        if ([orientation isEqualToString:@"Portrait"]) {
            titel = [[UILabel alloc] initWithFrame:CGRectMake(16, 0, 390, height)];
            eenheden = [[UILabel alloc] initWithFrame:CGRectMake(415, 0, 115, height)];
            hoeveelheden = [[UILabel alloc] initWithFrame:CGRectMake(540, 0, 120, height)];
        } else {
            titel = [[UILabel alloc] initWithFrame:CGRectMake(16, 0, 240, height)];
            eenheden = [[UILabel alloc] initWithFrame:CGRectMake(265, 0, 110, height)];
            hoeveelheden = [[UILabel alloc] initWithFrame:CGRectMake(385, 0, 115, height)];
        }
        
        titel.backgroundColor = [UIColor clearColor];
        titel.numberOfLines = 0;
        titel.lineBreakMode = UILineBreakModeWordWrap;
        titel.font = [UIFont boldSystemFontOfSize:15];
        titel.textColor = [UIColor colorWithRed:0.211 green:0.371 blue:0.648 alpha:1];
        
        eenheden.backgroundColor = [UIColor clearColor];
        eenheden.numberOfLines = 0;
        eenheden.lineBreakMode = UILineBreakModeWordWrap;
        eenheden.font = [UIFont systemFontOfSize:14];
        eenheden.textColor = [UIColor colorWithRed:0.211 green:0.371 blue:0.648 alpha:1];
        
        hoeveelheden.backgroundColor = [UIColor clearColor];
        hoeveelheden.numberOfLines = 0;
        hoeveelheden.lineBreakMode = UILineBreakModeWordWrap;
        hoeveelheden.font = [UIFont systemFontOfSize:14];
        hoeveelheden.textColor = [UIColor colorWithRed:0.211 green:0.371 blue:0.648 alpha:1];
        
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            if (info.of) 
                titel.text = [NSString stringWithFormat:@"of %@",info.product.titelNL];
            else 
                titel.text = info.product.titelNL;
            
            if ([info.eenhedenPerLengte count]>0) {
                [self setTextForLabel:eenheden withArray:info.eenhedenPerLengte withString:info.typeEenheid withPlace:place forLanguage:@"NL"];
            }
            
            if ([info.hoeveelhedenPerLengte count]>0) {
                [self setTextForLabel:hoeveelheden withArray:info.hoeveelhedenPerLengte withString:info.typeHoeveelheid withPlace:place forLanguage:@"NL"];
            }
        } else {
            if (info.of) 
                titel.text = [NSString stringWithFormat:@"où %@",info.product.titelFR];
            else 
                titel.text = info.product.titelFR;
            
            if ([info.eenhedenPerLengte count]>0) {
                [self setTextForLabel:eenheden withArray:info.eenhedenPerLengte withString:info.typeEenheid withPlace:place forLanguage:@"FR"];
            }            
            
            if ([info.hoeveelhedenPerLengte count]>0) {
                [self setTextForLabel:hoeveelheden withArray:info.hoeveelhedenPerLengte withString:info.typeHoeveelheid withPlace:place forLanguage:@"FR"];
            }
        }
        
        [infoView addSubview:titel];
        [titel release];
        
        [infoView addSubview:eenheden];
        [eenheden release];
        
        [infoView addSubview:hoeveelheden];
        [hoeveelheden release];
        
        infoView.tag = [info.product.productID intValue];
        [infoView addTarget:self action:@selector(buttonClick:) forControlEvents:UIControlEventTouchUpInside];
        
        [scrollView addSubview:infoView];
        [infoView release];
        
        teller++;
    }
    
    scrollView.contentSize = CGSizeMake(scrollView.frame.size.width, teller*height + (teller+1)*padding + categorieen*categorieHeight+10);
}

//Set orientation
- (void)setOrientation:(NSString *)orientation {
    if ([orientation isEqualToString:@"Portrait"]) {
        self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg-rekenmodule-p.jpg"]];
        
        scrollView.frame = CGRectMake(10, 474, 748, 509);
        btnNL.frame = CGRectMake(btnNL.frame.origin.x, 50, btnNL.frame.size.width, btnFR.frame.size.height);
        btnFR.frame = CGRectMake(btnFR.frame.origin.x, 50, btnFR.frame.size.width, btnFR.frame.size.height);
        toepassingTitel.frame = CGRectMake(35, 143, 655, 29);
        toepassingOmschrijving.frame = CGRectMake(28, 180, 498, 197);
        berekeningFoto.frame = CGRectMake(534, 190, berekeningFoto.frame.size.width, berekeningFoto.frame.size.height);
        selectText.frame = CGRectMake(38, 385, 662, 21);
        pickerButton.frame = CGRectMake(35, 414, pickerButton.frame.size.width, pickerButton.frame.size.height);
        logoImage.frame = CGRectMake(8, logoImage.frame.origin.y, 166, 57);
    } else {
        self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg-rekenmodule-l.jpg"]];
        
        scrollView.frame = CGRectMake(452, 246, 561, 471);
        btnNL.frame = CGRectMake(btnNL.frame.origin.x, 54, btnNL.frame.size.width, btnNL.frame.size.height);
        btnFR.frame = CGRectMake(btnFR.frame.origin.x, 54, btnFR.frame.size.width, btnFR.frame.size.height);
        toepassingTitel.frame = CGRectMake(35, 143, 375, 29);
        [toepassingTitel sizeToFit];
        berekeningFoto.frame = CGRectMake(35, 163+toepassingTitel.frame.size.height, berekeningFoto.frame.size.width, berekeningFoto.frame.size.height);
        if (![productToepassing.pic isEqualToString:@""]) {
            toepassingOmschrijving.frame = CGRectMake(28, berekeningFoto.frame.origin.y+berekeningFoto.frame.size.height+15, 375, 197);
        } else {
            toepassingOmschrijving.frame = CGRectMake(28, 163+toepassingTitel.frame.size.height, 375, 197);
        }
        
        selectText.frame = CGRectMake(480, 148, 662, 21);
        pickerButton.frame = CGRectMake(477, 177, pickerButton.frame.size.width, pickerButton.frame.size.height);
        logoImage.frame = CGRectMake(8, logoImage.frame.origin.y, logoImage.frame.size.width, logoImage.frame.size.height);
    }
    
    [self getBenodigdhedenForOrientation:orientation];
    currentOrientation = orientation;
}

//Load: info van productToepassing weergeven, orientatie, taal
- (void)viewDidLoad {
    [super viewDidLoad];
    
    toepassingOmschrijving.editable = NO;
    currentPickerValue = [[productToepassing.pickerViewData objectAtIndex:0] retain];
    [pickerButton setTitle:currentPickerValue forState:UIControlStateNormal];
    toepassingTitel.numberOfLines = 0;
    
    if (![productToepassing.pic isEqualToString:@""]) {
        UIImage *img = [[UIImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:productToepassing.pic ofType:@"jpg"]];
        berekeningFoto.image = img;
        [img release];
        berekeningFoto.hidden = NO;
        toepassingOmschrijving.frame = CGRectMake(toepassingOmschrijving.frame.origin.x, toepassingOmschrijving.frame.origin.y, 490, toepassingOmschrijving.frame.size.height);
    } else {
        berekeningFoto.hidden = YES;
        toepassingOmschrijving.frame = CGRectMake(toepassingOmschrijving.frame.origin.x, toepassingOmschrijving.frame.origin.y, 705, toepassingOmschrijving.frame.size.height);
    }
    
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation)) {
        [self setOrientation:@"Portrait"];
    } else {
        [self setOrientation:@"Landscape"];
    }
    
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        [self setNL:nil];
    } else {
        [self setFR:nil];
    }
}

//Rotate
- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration {
    if (UIInterfaceOrientationIsPortrait(toInterfaceOrientation)) {
        [self setOrientation:@"Portrait"];
    } else {
        [self setOrientation:@"Landscape"];
    }
}
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}

//Klikken op één van de benodigdheden: product openen (ProductStartView)
- (void)buttonClick:(UIButton *)sender {
    if ([sender isKindOfClass:[UIButton class]]) {
        for (ProductInformatie *info in productToepassing.productInformaties) {
            if ([info.product.productID integerValue] == sender.tag) {
                ProductStartView *sv = [[ProductStartView alloc] init];
                sv.delegate = self;
                sv.startCategorie = info.product.productenCategorie;
                sv.categorieArray = self.categorieArray;
                sv.product = info.product;
                sv.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
                [self presentModalViewController:sv animated:YES];
                [sv release];
            }
        }
    }
}

//Verander taal
- (void)veranderTaal {
    [delegate changeLanguage];
    [self getBenodigdhedenForOrientation:currentOrientation];
}
- (IBAction)setNL:(id)sender {
    btnNL.enabled = NO;
    btnFR.enabled = YES;
    
    [Brain brain].currentLang = @"NL";
    
    toepassingTitel.text = productToepassing.titelNL;
    toepassingOmschrijving.text = productToepassing.descriptionNL;
    selectText.text = productToepassing.tekstNL;
    
    [self veranderTaal];
}
- (IBAction)setFR:(id)sender {
    btnNL.enabled = YES;
    btnFR.enabled = NO;
    
    [Brain brain].currentLang = @"FR";
    
    toepassingTitel.text = productToepassing.titelFR;
    toepassingOmschrijving.text = productToepassing.descriptionFR;
    selectText.text = productToepassing.tekstFR;
    
    [self veranderTaal];
}

//Delegate method
- (void)changeLanguage {
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        [self setNL:nil];
    } else {
        [self setFR:nil];
    }
}

//Terugkeren naar BerekeningModule Controller
- (IBAction)goBackHome {
    [self dismissModalViewControllerAnimated:YES];
}

//Popover controller met pickerview weergeven
- (IBAction)showPicker {
    UIViewController *vc = [[UIViewController alloc] init];
    vc.contentSizeForViewInPopover = CGSizeMake(75, 180);
    
    UIPickerView *pkv = [[UIPickerView alloc] initWithFrame:CGRectMake(0, 0, 75, 180)];
    pkv.showsSelectionIndicator = YES;
    
    pkv.delegate = self;
    pkv.dataSource = self;
    
    [pickerButton setTitle:currentPickerValue forState:UIControlStateNormal];
    
    for (int i = 0; i < [productToepassing.pickerViewData count]; i++) {
        if ([[productToepassing.pickerViewData objectAtIndex:i] isEqualToString:currentPickerValue]) {
            [pkv selectRow:i inComponent:0 animated:NO];
        }
    }
    
    [vc.view addSubview:pkv];
    [pkv release];
    
    UIPopoverController *pop = [[UIPopoverController alloc] initWithContentViewController:vc];
    pop.delegate = self;
    [vc release];
    
    [pop presentPopoverFromRect:pickerButton.frame inView:self.view permittedArrowDirections:UIPopoverArrowDirectionLeft animated:YES];
}

//Release popover bij dismiss
- (void)popoverControllerDidDismissPopover:(UIPopoverController *)popoverController {
    [popoverController release];
}

//Pickerview Delegate methods
- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView {
    return 1;
}
- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component {
    return [productToepassing.pickerViewData count];
}
- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component {
    return [productToepassing.pickerViewData objectAtIndex:row];
}

//Aantallen bij benodigdheden aanpassen na dataselectie in pickerView
- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component {
    currentPickerValue = [[pickerView.delegate pickerView:pickerView titleForRow:row forComponent:component] retain];
    [pickerButton setTitle:currentPickerValue forState:UIControlStateNormal];
    
    [self getBenodigdhedenForOrientation:currentOrientation];
}

//Delegate methods (optional)
//- (void)toonProducten:(ProductenCategorie *)categorie forProduct:(Product *)product forOrientation:(NSString *)orientation justRotate:(BOOL)justRotate{}
//- (void)kiesProduct:(Product *)aProduct forOrientation:(NSString *)orientation{}
//- (void)kiesProduct:(Product *)aProduct{}

- (void)viewDidUnload {
    [super viewDidUnload];
    
    toepassingTitel = nil;
    toepassingOmschrijving = nil;
    btnNL = nil;
    btnFR = nil;
    selectText = nil;
    pickerButton = nil;
    scrollView = nil;
    berekeningFoto = nil;
    logoImage = nil;
}
- (void)dealloc {
    [delegate release];
    [productToepassing release];
    [currentPickerValue release];
    [super dealloc];
}

@end
