//
//  Berekeningsmodule.m
//  Gyproc
//
//  Created by Bert Carrein on 30/05/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "Berekeningsmodule.h"
#import "Brain.h"


@implementation Berekeningsmodule

@synthesize managedObjectContext;
@synthesize btnNL, btnFR;
@synthesize titel, tekst;
@synthesize logoImage, toepassingScrollView;
@synthesize categorieArray;
@synthesize productToepassingen;
@synthesize typeArray;
@synthesize moduleSwitch;

//Set orientation
- (void)setOrientation:(NSString *)orientation {
    if ([orientation isEqualToString:@"Portrait"]) {
        self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg-berekeningsmodule-p.jpg"]];
        
        for (UIButton *btn in [[toepassingScrollView.subviews copy] autorelease]) {
            if ([btn isKindOfClass:[UIButton class]]) {
                btn.frame = CGRectMake(btn.frame.origin.x, btn.frame.origin.y, 526, btn.frame.size.height);
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-notselected-p.png"] forState:UIControlStateNormal];
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-hl-p.png"] forState:UIControlStateHighlighted];
                
                for (UILabel *lbl in [[btn.subviews copy] autorelease]) {
                    if ([lbl isKindOfClass:[UILabel class]]) {
                        lbl.frame = CGRectMake(lbl.frame.origin.x, lbl.frame.origin.y, 456, lbl.frame.size.height);
                    }
                }
            }
        }
        
        btnNL.frame = CGRectMake(581, 56, btnNL.frame.size.width, btnNL.frame.size.height);
        btnFR.frame = CGRectMake(634, 56, btnFR.frame.size.width, btnFR.frame.size.height);
        moduleSwitch.frame = CGRectMake(296, 0, moduleSwitch.frame.size.width, moduleSwitch.frame.size.height);
        logoImage.frame = CGRectMake(85, 14, logoImage.frame.size.width, logoImage.frame.size.height);
        toepassingScrollView.frame = CGRectMake(90, 262, 588, 695);
        titel.frame = CGRectMake(123, 159, 277, 30);
        tekst.frame = CGRectMake(123, 190, 517, 41);
    } else {
        self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg-berekeningsmodule-l.jpg"]];
        
        for (UIButton *btn in [[toepassingScrollView.subviews copy] autorelease]) {
            if ([btn isKindOfClass:[UIButton class]]) {
                btn.frame = CGRectMake(btn.frame.origin.x, btn.frame.origin.y, 762, btn.frame.size.height);
                [btn setBackgroundImage:[UIImage imageNamed:@"rekenmodule-notselected-l.png"] forState:UIControlStateNormal];
                [btn setBackgroundImage:[UIImage imageNamed:@"rekenmodule-hl-l.png"] forState:UIControlStateHighlighted];
                
                for (UILabel *lbl in [[btn.subviews copy] autorelease]) {
                    if ([lbl isKindOfClass:[UILabel class]]) {
                        lbl.frame = CGRectMake(lbl.frame.origin.x, lbl.frame.origin.y, 692, lbl.frame.size.height);
                    }
                }
            }
        }
        
        btnNL.frame = CGRectMake(828, 54, btnNL.frame.size.width, btnNL.frame.size.height);
        btnFR.frame = CGRectMake(881, 54, btnFR.frame.size.width, btnFR.frame.size.height);
        moduleSwitch.frame = CGRectMake(445, 0, moduleSwitch.frame.size.width, moduleSwitch.frame.size.height);
        logoImage.frame = CGRectMake(100, 13, logoImage.frame.size.width, logoImage.frame.size.height);
        toepassingScrollView.frame = CGRectMake(100, 261, 824, 461);
        titel.frame = CGRectMake(134, 159, 277, 30);
        tekst.frame = CGRectMake(134, 190, 517, 41);
    }
}

//Rotate
- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration {
    if (UIInterfaceOrientationIsPortrait(toInterfaceOrientation)) {
        [self setOrientation:@"Portrait"];
    } else {
        [self setOrientation:@"Landscape"];
    }
}
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
	return YES;
}

//Toepassing ophalen die bij button hoort
- (ProductToepassing *)getToepassingForButton:(UIButton *)sender {
    for (ProductToepassing *toep in self.productToepassingen) {
        for (UILabel *lbl in [[sender.subviews copy] autorelease]) {
            if ([lbl isKindOfClass:[UILabel class]]) {
                if ([[Brain brain].currentLang isEqualToString:@"NL"] && [lbl.text isEqualToString:toep.titelNL] || [[Brain brain].currentLang isEqualToString:@"FR"] && [lbl.text isEqualToString:toep.titelFR]) {
                    return toep;
                }
            }
        }
    }
    return nil;
}

//Toepassing openen na touch
- (void)openToepassing:(id)sender {
    BerekeningToepassing *bt =  [[BerekeningToepassing alloc] initWithProductToepassing:[self getToepassingForButton:sender] andDelegate:self];
    bt.categorieArray = self.categorieArray;
    bt.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
    [self presentModalViewController:bt animated:YES];
    [bt release];
}

//Toepassingen weergeven in scrollview
- (void)toonToepassingenForOrientation:(NSString *)orientation {
    for (UIButton *cat in [[toepassingScrollView.subviews copy] autorelease]) {
        if ([cat isKindOfClass:[UIButton class]]) {
            [cat removeFromSuperview];
        }
    }
    
    int i = 0;
    int height = 63;
    int width = 0;
    if ([orientation isEqualToString:@"Portrait"]) {
        width = 526;
    } else {
        width = 360;
    }
    int padding = 20;
    
    for (ProductToepassing *toep in productToepassingen) {
        UIButton *btn = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
        [btn addTarget:self action:@selector(openToepassing:) forControlEvents:UIControlEventTouchUpInside];
        btn.frame = CGRectMake(31, 31+i*(padding+height), width, height);
        btn.titleLabel.textAlignment = UITextAlignmentLeft;
        btn.tag = i;
        
        UILabel *lblTitel = [[UILabel alloc] initWithFrame:CGRectMake(25, 0, width-80, height)];
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            lblTitel.text = [toep valueForKey:@"titelNL"];
        } else {
            lblTitel.text = [toep valueForKey:@"titelFR"];
        }
        
        lblTitel.numberOfLines = 0;
        lblTitel.lineBreakMode = UILineBreakModeWordWrap;
        lblTitel.textColor = [UIColor colorWithRed:0.211 green:0.371 blue:0.648 alpha:1];
        lblTitel.font = [UIFont boldSystemFontOfSize:17];
        lblTitel.backgroundColor = [UIColor clearColor];
        [btn addSubview:lblTitel];
        [lblTitel release];
        
        [toepassingScrollView addSubview:btn];
        [btn release];
        i++;
    }
    
    toepassingScrollView.contentSize = CGSizeMake(toepassingScrollView.frame.size.width, 62+[productToepassingen count]*(padding+height)-padding);
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation)) {
        [self setOrientation:@"Portrait"];
    } else {
        [self setOrientation:@"Landscape"];
    }
}

//Load: init moduleswitch, taal, orientatie
- (void)viewDidLoad {
    [super viewDidLoad];
    
    [moduleSwitch initWithIndex:1 animated:NO];
    
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        [self setNL:nil];
    } else {
        [self setFR:nil];
    }
    
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation)) {
        [self setOrientation:@"Portrait"];
    } else {
        [self setOrientation:@"Landscape"];
    }
}

//Verander taal
- (void)veranderTaal {
    [moduleSwitch changeLanguage];
    [self toonToepassingenForOrientation:@"none"];
}
- (IBAction)setNL:(id)sender {
    btnNL.enabled = NO;
    btnFR.enabled = YES;
    
    [Brain brain].currentLang = @"NL";
    
    titel.text = @"Berekeningsmodule";
    tekst.text = @"Bereken hier hoeveel Gyproc-producten je nodig hebt voor de onderstaande toepassingen en reken uit hoeveel materiaal je daarvoor dient aan te kopen.";
    
    [self veranderTaal];
}
- (IBAction)setFR:(id)sender {
    btnNL.enabled = YES;
    btnFR.enabled = NO;
    
    [Brain brain].currentLang = @"FR";
    
    titel.text = @"Module de calcul";
    tekst.text = @"Calculez ici combien de produits Gyproc vous avez besoin des applications ci-dessous et calculez combien de matériels vous devez acheter.";
    
    [self veranderTaal];
}

//Delegate method
- (void)changeLanguage {
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        [self setNL:nil];
    } else {
        [self setFR:nil];
    }
}

//View did appear: init moduleSwitch (is nodig als men terugkeert van Store Locator)
- (void)viewDidAppear:(BOOL)animated {
    [moduleSwitch initWithIndex:1 animated:NO];
}

- (void)viewDidUnload {
    [super viewDidUnload];
    
    btnNL = nil;
    btnFR = nil;
    logoImage = nil;
    titel = nil;
    tekst = nil;
    moduleSwitch = nil;
}
- (void)dealloc {
    [categorieArray release];
    [typeArray release];
    [productToepassingen release];
    [managedObjectContext release];
    [super dealloc];
}

@end
