//
//  CategorieSwitchView.m
//  Gyproc
//
//  Created by Bert Carrein on 6/04/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "CategorieSwitchView.h"
#import "Brain.h"


@implementation CategorieSwitchView

@synthesize categorieLabel, countLabel;
@synthesize currentCategorie;
@synthesize delegate;
@synthesize currentIndex;

//Set GUI
- (void)setGUIForToepassing:(id)toepassing {
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        categorieLabel.text = [[delegate.categorieArray objectAtIndex:currentIndex] titelNL];
    } else {
        categorieLabel.text = [[delegate.categorieArray objectAtIndex:currentIndex] titelFR];
    }
    
    countLabel.text = [NSString stringWithFormat:@"(%i/%i)",currentIndex+1,count];
    currentCategorie = [delegate.categorieArray objectAtIndex:currentIndex];
    
    [delegate toonToepassingen:currentCategorie forToepassing:toepassing forOrientation:@"none" justRotate:NO];
}

//init: currentIndex (current Categorie)
- (void)initCategorieSwitch:(NSMutableArray *)anArray forStartCategorie:(ToepassingenCategorie *)start forToepassing:(Toepassing *)toepassing {
    int i=0;
    for (ToepassingenCategorie *cat in delegate.categorieArray) {
        if (cat == start) {
            currentIndex = i;
        }
        i++;
    }

    count = [delegate.categorieArray count];
    [self setGUIForToepassing:toepassing];
}

//left or right press
- (IBAction)leftPressed:(id)sender {
    if (currentIndex>=1) {
        currentIndex--;
        [self setGUIForToepassing:nil];
    }
}
- (IBAction)rightPressed:(id)sender {
    if (currentIndex-1<count-2) {
        currentIndex++;
        [self setGUIForToepassing:nil];
    }
}

@end
