//
//  LargeToepassingView.h
//  Gyproc
//
//  Created by Bert Carrein on 26/04/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <MediaPlayer/MediaPlayer.h>

#import "Toepassing.h"
#import "Stap.h"
#import "ToepassingenCategorie.h"
#import "ToepassingView.h"
#import "ToepassingDelegate.h"
#import "FotoView.h"
#import "LargeToepassingDelegate.h"
#import "GANTracker.h"

@class Reachability;

//Aparte view voor de gedetailleerde weergave van de toepassing en de stappen in StartView
@interface LargeToepassingView : UIView <LargeToepassingDelegate, UIScrollViewDelegate, UIGestureRecognizerDelegate, UIPopoverControllerDelegate> {
    Toepassing *toepassing;
    int currentStap;
    int oldStap;
    id<ToepassingDelegate> delegate;
    NSString *currentOrientation;
    BOOL exists;
    UIView *whiteView;
    
    Reachability* internetReachable;
    Reachability* hostReachable;
}

@property (nonatomic) BOOL internetActive;
@property (nonatomic) BOOL hostActive;

@property (nonatomic, retain) Toepassing *toepassing;
@property (nonatomic) int currentStap;
@property (nonatomic, retain) id<ToepassingDelegate> delegate;
@property (nonatomic, retain) UIView *whiteView;

@property (nonatomic, retain) UIPopoverController *popoverInfo;
@property (nonatomic, retain) UIPopoverController *popoverWistjedat;

@property (nonatomic, retain) IBOutlet UILabel *toepassingTitel;
@property (nonatomic, retain) IBOutlet UIScrollView *stapScrollView;
@property (nonatomic, retain) IBOutlet UIButton *speelVideo;
@property (nonatomic, retain) IBOutlet UIButton *wistjedat;

- (void) checkNetworkStatus:(NSNotification *)notice;

- (void)setOrientation:(NSString *)orientation;
- (void)initGUI:(Toepassing *)aToepassing forOrientation:(NSString *)orientation;
- (void)changeOrientation:(NSString *)orientation;
- (void)setStapForTag:(int)tag animated:(BOOL)animated;
- (IBAction)touchStapButton:(id)sender;
- (IBAction)speelVideo:(id)sender;
- (IBAction)wistJeDat:(id)sender;
- (void)setLanguage;
- (void)showWhiteView;

@end
