//
//  LargeToepassingView.m
//  Gyproc
//
//  Created by Bert Carrein on 26/04/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "LargeToepassingView.h"
#import <QuartzCore/QuartzCore.h>

#import "PopoverInfo.h"
#import "PopoverWistjedat.h"
#import "Reachability.h"
#import "Brain.h"


@implementation LargeToepassingView

@synthesize toepassing,currentStap,delegate;
@synthesize toepassingTitel;
@synthesize whiteView;
@synthesize stapScrollView;
@synthesize popoverInfo, popoverWistjedat;
@synthesize speelVideo, wistjedat;
@synthesize internetActive, hostActive;

//FotoView dismiss
- (void)dismissFotoView:(UIViewController *)viewController {
    [delegate dismissFotoView:viewController];
}

//whiteview onzichtbaar na einde overgang tussen 2 toepassingen
- (void)hideWhiteView {
    self.alpha = 1;
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.35];
    whiteView.alpha = 0;
    [UIView commitAnimations];
}

//white view tonen (overgang tussen 2 toepassingen)
- (void)showWhiteView {
    if (!whiteView) {
        whiteView = [[UIView alloc] init];
        whiteView.backgroundColor = [UIColor whiteColor];
        whiteView.alpha = 0;
        [self addSubview:whiteView];
    }
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.35];
    whiteView.alpha = 1;
    [UIView commitAnimations];
    [self performSelector:@selector(hideWhiteView) withObject:nil afterDelay:0.35];
}

//foto in fullscreen weergeven adhv FotoView Controller (zoom & double tap)
- (void)tapMethod:(UIGestureRecognizer *)sender {
    if ([sender isKindOfClass:[UIGestureRecognizer class]]) {
        if ([sender isKindOfClass:[UITapGestureRecognizer class]] || [sender isKindOfClass:[UIPinchGestureRecognizer class]] && [(UIPinchGestureRecognizer *)sender scale] > 1) {
            if ([sender.view isKindOfClass:[UIImageView class]]) {
                FotoView *fotoView = [[FotoView alloc] initWithImageView:(UIImageView *)sender.view andStappen:toepassing.stappen];
                fotoView.delegate = self;
                [delegate presentFotoView:fotoView];
                [fotoView release];
            }
        }
    }
}

//Images bij stappen tonen (adhv lazy loading)
- (void)showImages:(int)newStap {
    for (UIImageView *img in [[stapScrollView.subviews copy] autorelease]) {
        if ([img isKindOfClass:[UIImageView class]]) {
            for (Stap *stap in toepassing.stappen) {
                if ([stap.stap intValue] == img.tag) {
                    if (img.tag >= newStap-2 && img.tag <= newStap+2) {
                        if (!img.image) {
                            UIImage *image = [[UIImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:[NSString stringWithFormat:@"%@_%i", stap.toepassing.stapImageURL, img.tag] ofType:@"jpg"]];
                            img.image = image;
                            [image release];
                        }
                        img.hidden = NO;
                    } else {
                        img.hidden = YES;
                    }
                }
            }
        }
    }
}

//Wist je dat popover tonen
- (IBAction)wistJeDat:(id)sender {
    PopoverWistjedat *vc = [[PopoverWistjedat alloc] initWithToepassing:toepassing];
    vc.delegate = self;
    popoverWistjedat = [[UIPopoverController alloc] initWithContentViewController:vc];
    [vc release];
    popoverWistjedat.delegate = self;
    [popoverWistjedat presentPopoverFromRect:wistjedat.frame inView:self permittedArrowDirections:UIPopoverArrowDirectionAny animated:YES];
}

//wist je dat popover sluiten
- (void)closeWistjedatPopover {
    if (popoverWistjedat) {
        if ([popoverWistjedat isKindOfClass:[UIPopoverController class]]) {
            [popoverWistjedat dismissPopoverAnimated:YES];
        }
    }
}

//Info popover sluiten
- (void)closeInfoPopover {
    if (popoverInfo) {
        if ([popoverInfo isKindOfClass:[UIPopoverController class]]) {
            [popoverInfo dismissPopoverAnimated:YES];
        }
    }
}

//Video afspelen
- (IBAction)speelVideo:(id)sender {
    if (self.internetActive && self.hostActive) {
        NSURL *url;
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            url = [NSURL URLWithString:toepassing.videoURLNL];
        } else {
            url = [NSURL URLWithString:toepassing.videoURLFR];
        }
        
        [delegate speelVideo:url];
    } else {
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Geen verbinding" message:@"Er is geen internetverbinding beschikbaar voor het afspelen van dit filmpje." delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
            [alert show];
            [alert release];
        } else {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Pas de connection" message:@"Er is geen internetverbinding beschikbaar voor het afspelen van dit filmpje." delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
            [alert show];
            [alert release];
        }
    }
}

//Info bij stap tonen
- (void)pushInfo:(id)sender {
    if ([sender isKindOfClass:[UIButton class]]) {
        UIButton *btn = [(UIButton *)sender retain];
        for (Stap *stap in toepassing.stappen) {
            if ([stap.stap intValue] == btn.tag) {
                PopoverInfo *info = [[PopoverInfo alloc] initWithStap:stap];
                info.delegate = self;
                popoverInfo = [[UIPopoverController alloc] initWithContentViewController:info];
                [info release];
                popoverInfo.delegate = self;
                [popoverInfo presentPopoverFromRect:btn.frame inView:stapScrollView permittedArrowDirections:UIPopoverArrowDirectionAny animated:YES];
            }
        }
        
        [btn release];
    }
}

//release popovers
- (void)popoverControllerDidDismissPopover:(UIPopoverController *)popoverController {
    if (popoverInfo) {
        [popoverInfo release];
        popoverInfo = nil;
    }
    if (popoverWistjedat) {
        [popoverWistjedat release];
        popoverWistjedat = nil;
    }
}

//Stappen weergeven in scrollview
- (void)setStappen {
    for (UIButton *btn in [[self.subviews copy] autorelease]) {
        if ([btn isKindOfClass:[UIButton class]]) {
            btn.hidden = YES;
        }
    }
    
    for (UIView *view in [[stapScrollView.subviews copy] autorelease]) {
        if ([view isKindOfClass:[UIImageView class]]) {
            UIImageView *image = (UIImageView *)view;
            image.image = nil;
        }
        [view removeFromSuperview];
    }
    
    int teller = 0;
    for (int i = 1; i<=[toepassing.stappen count]; i++) {
        for (Stap *stap in toepassing.stappen) {
            if ([stap.stap intValue] == i) {
                for (UIButton *btn in [[self.subviews copy] autorelease]) {
                    if ([btn isKindOfClass:[UIButton class]]) {
                        if ([btn.titleLabel.text intValue] == i) {
                            btn.hidden = NO;
                        }
                    }
                }
                
                float leftImage = (i-1)*stapScrollView.frame.size.width;
                UIScrollView *textScroll = [[UIScrollView alloc] init];
                UIImageView *img = [[UIImageView alloc] init];
                img.contentMode = UIViewContentModeScaleAspectFill;
                img.clipsToBounds = YES;
                img.tag = i;
                img.userInteractionEnabled = YES;
                
                if ([currentOrientation isEqualToString:@"Portrait"]) {
                    img.frame = CGRectMake(leftImage, 0, 726, 400);
                    textScroll.frame = CGRectMake(leftImage, 410, stapScrollView.frame.size.width, 110);
                } else {
                    img.frame = CGRectMake(leftImage, 0, 589, 325);
                    textScroll.frame = CGRectMake(leftImage, 335, stapScrollView.frame.size.width, 140);
                }
                
                UIGestureRecognizer *tapRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(tapMethod:)];
                [(UITapGestureRecognizer *)tapRecognizer setNumberOfTouchesRequired:1];
                [(UITapGestureRecognizer *)tapRecognizer setNumberOfTapsRequired:2];
                [img addGestureRecognizer:tapRecognizer];
                tapRecognizer.delegate = self;
                [tapRecognizer release];
                
                UIGestureRecognizer *pinchRecognizer = [[UIPinchGestureRecognizer alloc] initWithTarget:self action:@selector(tapMethod:)];
                [img addGestureRecognizer:pinchRecognizer];
                pinchRecognizer.delegate = self;
                [pinchRecognizer release];
                [stapScrollView addSubview:img];
                
                if (![stap.tipNL isEqualToString:@""]) {
                    UIButton *infoButton = [UIButton buttonWithType:UIButtonTypeCustom];
                    [infoButton setImage:[UIImage imageNamed:@"info-btn-notselected.png"] forState:UIControlStateNormal];
                    [infoButton setImage:[UIImage imageNamed:@"info-btn-hl.png"] forState:UIControlStateHighlighted];
                    [infoButton sizeToFit];
                    infoButton.frame = CGRectMake(img.frame.origin.x+img.frame.size.width-infoButton.frame.size.width-15, img.frame.size.height-infoButton.frame.size.height-15, infoButton.frame.size.width, infoButton.frame.size.height);
                    infoButton.tag = i;
                    [infoButton addTarget:self action:@selector(pushInfo:) forControlEvents:UIControlEventTouchUpInside];
                    [stapScrollView addSubview:infoButton];
                    [img release];
                }
                
                UILabel *textView = [[UILabel alloc] init]; 
                
                if ([currentOrientation isEqualToString:@"Portrait"]) {
                    textScroll.frame = CGRectMake(leftImage, 410, stapScrollView.frame.size.width, 110);
                    textView.frame = CGRectMake(0, -3, textScroll.frame.size.width, 110);
                } else {
                    textScroll.frame = CGRectMake(leftImage, 335, stapScrollView.frame.size.width, 140);
                    textView.frame = CGRectMake(0, -3, textScroll.frame.size.width, 140);
                }
                
                textView.font = [UIFont systemFontOfSize:15];
                textView.textColor = [UIColor grayColor];
                textView.lineBreakMode = UILineBreakModeWordWrap;
                textView.numberOfLines = 0;
                textView.adjustsFontSizeToFitWidth = NO;
                textScroll.showsVerticalScrollIndicator = YES;
                
                if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
                    textView.text = stap.tekstNL;
                } else {
                    textView.text = stap.tekstFR;
                }
                
                [textView sizeToFit];
                textScroll.contentSize = CGSizeMake(textScroll.frame.size.width, textView.frame.size.height-3);
                
                [textScroll addSubview:textView];
                [textView release];
                [stapScrollView addSubview:textScroll];
                [textScroll release];
                
                teller = i;
            }
        }
    }
    
    if (teller) {
        stapScrollView.contentSize = CGSizeMake(teller*stapScrollView.frame.size.width, stapScrollView.frame.size.height);
        
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            toepassingTitel.text = toepassing.titelNL;
            if (![toepassing.videoURLNL isEqualToString:@"geen"]) 
                speelVideo.hidden = NO;
            else
                speelVideo.hidden = YES;
        } else {
            toepassingTitel.text = toepassing.titelFR;
            if (![toepassing.videoURLFR isEqualToString:@"geen"]) 
                speelVideo.hidden = YES;
            else
                speelVideo.hidden = YES;
        }
        wistjedat.hidden = NO;
    } else {
        stapScrollView.contentSize = CGSizeMake(0, stapScrollView.frame.size.height);
    }
}

//gesture recognizer delegate method
- (BOOL)gestureRecognizer:(UIGestureRecognizer *)gestureRecognizer shouldReceiveTouch:(UITouch *)touch {
    if (([touch.view isKindOfClass:[UIImageView class]])) {
        return YES;
    }
    return YES;
}

//set orientation
- (void)setOrientation:(NSString *)orientation {
    int yLabel = 10;
    int wLabel = 721;
    int topStappen = 55;
    
    if ([orientation isEqualToString:@"Portrait"]) {
        self.frame = CGRectMake(10, 355, 748, 629);
        whiteView.frame = CGRectMake(10, 10, 727, 625);
        stapScrollView.frame = CGRectMake(10, 110, 726, 525);
        speelVideo.frame = CGRectMake(645, topStappen, speelVideo.frame.size.width, speelVideo.frame.size.height);
        wistjedat.frame = CGRectMake(695, topStappen, speelVideo.frame.size.width, speelVideo.frame.size.height);
    } else {
        self.frame = CGRectMake(402, 125, 612, 615);
        yLabel = 12;
        wLabel = 480;
        topStappen = 65;
        
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            toepassingTitel.text = toepassing.titelNL;
        } else {
            toepassingTitel.text = toepassing.titelFR;
        }
        whiteView.frame = CGRectMake(10, 10, 591, 595);
        stapScrollView.frame = CGRectMake(10, 119, 589, 530);
        speelVideo.frame = CGRectMake(509, 12, speelVideo.frame.size.width, speelVideo.frame.size.height);
        wistjedat.frame = CGRectMake(559, 12, speelVideo.frame.size.width, speelVideo.frame.size.height);
    }
    
    toepassingTitel.frame = CGRectMake(toepassingTitel.frame.origin.x, yLabel, wLabel, toepassingTitel.frame.size.height);
    for (UIButton *btn in [[self.subviews copy] autorelease]) {
        if ([btn isKindOfClass:[UIButton class]]) {
            if (btn.tag!=0)
                btn.frame = CGRectMake(btn.frame.origin.x, topStappen, btn.frame.size.width, btn.frame.size.height);
        }
    }
    
    if (popoverInfo) {
        if ([popoverInfo isKindOfClass:[UIPopoverController class]]) {
            [popoverInfo dismissPopoverAnimated:YES];
        }
    }
        
    if (popoverWistjedat) {
        if ([popoverWistjedat isKindOfClass:[UIPopoverController class]]) {
            [popoverWistjedat dismissPopoverAnimated:YES];
        }
    }
    
    [self setStappen];
}

//Check network status
- (void)checkNetworkStatus:(NSNotification *)notice {
    NetworkStatus internetStatus = [internetReachable currentReachabilityStatus];
    switch (internetStatus) {
        case NotReachable: {
            self.internetActive = NO;
            break;
            
        }
        case ReachableViaWiFi: {
            self.internetActive = YES;
            break;
            
        }
        case ReachableViaWWAN: {
            self.internetActive = YES;
            break;
        }
    }
    
    NetworkStatus hostStatus = [hostReachable currentReachabilityStatus];
    switch (hostStatus) {
        case NotReachable: {
            self.hostActive = NO;
            break;
        }
        case ReachableViaWiFi: {
            self.hostActive = YES;
            break;
        }
        case ReachableViaWWAN: {
            self.hostActive = YES;
            break;
        }
    }
}

//Init GUI: orientatie, internet test, set stap
- (void)performInitAfterDelayForToepassing:(Toepassing *)aToepassing {
    popoverInfo = nil;
    popoverWistjedat = nil;
    
    for (UIImageView *img in [[stapScrollView.subviews copy] autorelease]) {
        if ([img isKindOfClass:[UIImageView class]]) {
            img.image = nil;
        }
    }
    
    toepassing = [aToepassing retain];
    
    [self setOrientation:currentOrientation];
    currentStap = oldStap = 1;
    [self setLanguage];
    stapScrollView.delegate = self;
    
    //Internet connectie?
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(checkNetworkStatus:) name:kReachabilityChangedNotification object:nil];
    
    internetReachable = [[Reachability reachabilityForInternetConnection] retain];
    [internetReachable startNotifier];
    
    hostReachable = [[Reachability reachabilityWithHostName: @"www.apple.com"] retain];
    [hostReachable startNotifier];
    
    NSError *error;
    if (![[GANTracker sharedTracker] trackPageview:[NSString stringWithFormat:@"/%@/%@ %@",toepassing.toepassingenCategorie.titelNL,toepassing.titelNL,[Brain brain].currentLang] withError:&error]) {
        NSLog(@"GA Error StartView.h: viewDidLoad");
    }
    [error release];
}

//Buttons hiden
- (void)hideButtons {
    for (UIButton *view in [[self.subviews copy] autorelease]) {
        if ([view isKindOfClass:[UIButton class]]) {
            view.enabled = YES;
            view.titleLabel.font = [UIFont systemFontOfSize:13];
        }
    }
}

//init GUI gebeurt pas na 0.325 s
- (void)initGUI:(Toepassing *)aToepassing forOrientation:(NSString *)orientation {
    currentOrientation = [orientation retain];
    [self performSelector:@selector(performInitAfterDelayForToepassing:) withObject:aToepassing afterDelay:0.325];
}

//orientatie veranderen
- (void)changeOrientation:(NSString *)orientation {
    currentOrientation = [orientation retain];
    [self setOrientation:orientation];
}

//Stap goed zetten
- (void)setStapForTag:(int)tag animated:(BOOL)animated {
    currentStap = tag;
    if (animated) {
        [stapScrollView scrollRectToVisible:CGRectMake((tag-1)*stapScrollView.frame.size.width, 0, stapScrollView.frame.size.width, stapScrollView.frame.size.height) animated:NO];
    }
    
    [self hideButtons];
    for (UIButton *view in [[self.subviews copy] autorelease]) {
        if ([view isKindOfClass:[UIButton class]]) {
            if ([view.titleLabel.text intValue] == tag) {
                view.enabled = NO;
                view.titleLabel.font = [UIFont boldSystemFontOfSize:13];
            }
        }
    }
    
    [self showImages:currentStap];
}

//Na klikken op stap button, stap goed zetten
- (IBAction)touchStapButton:(UIButton *)sender {
    [self setStapForTag:[sender.titleLabel.text intValue] animated:YES];
}

//stap goed zetten
- (void)setLanguage {
    [self setStapForTag:currentStap animated:YES];
}

//scrollview delegate method: stap kiezen bij einde scroll
- (void)scrollViewDidScroll:(UIScrollView *)scrollView {
    int newStap = (scrollView.contentOffset.x+scrollView.frame.size.width/2)/scrollView.frame.size.width+1;
    if (newStap!=currentStap) {
        [self setStapForTag:scrollView.contentOffset.x/scrollView.frame.size.width+1 animated:NO];
    }
}

- (void)dealloc {
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    [currentOrientation release];
    [whiteView release];
    [toepassing release];
    [super dealloc];
}

@end
