//
//  ModuleSwitch.m
//  Gyproc
//
//  Created by Bert Carrein on 14/06/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "ModuleSwitch.h"
#import "Brain.h"
#import "Start.h"
#import "Berekeningsmodule.h"
#import "StoreLocator.h"
#import "Productcataloog.h"


@implementation ModuleSwitch

@synthesize moduleScrollView;
@synthesize module;
@synthesize moduleArray;

//Klikken op een module icon: nieuwe controller openen
- (void)click:(UIButton *)sender {
    NSDictionary *dict = [moduleArray objectAtIndex:sender.tag];
    NSString *titel = [dict objectForKey:@"titelNL"];
    module.text = titel;
    
   if ([titel isEqualToString:@"Toepassingmodule"]) {
        Start *s = [[Start alloc] init];
        s.categorieArray = [Brain brain].toepassingCategorieArray;
        
        s.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
        [(UIViewController *)[self.superview nextResponder] presentModalViewController:s animated:YES];
        [s release];
   } else if ([titel isEqualToString:@"Berekeningsmodule"]) {
       Berekeningsmodule *b = [[Berekeningsmodule alloc] init];
       b.categorieArray = [Brain brain].productCategorieArray;
       b.productToepassingen = [Brain brain].productToepassingen;
       b.typeArray = [Brain brain].typeArray;
       
       b.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
       [(UIViewController *)[self.superview nextResponder] presentModalViewController:b animated:YES];
       [b release];
   } else if ([titel isEqualToString:@"Store Locator"]) {
       StoreLocator *s = [[StoreLocator alloc] init];
       
       s.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
       [(UIViewController *)[self.superview nextResponder] presentModalViewController:s animated:YES];
       [s release];
   } else if ([titel isEqualToString:@"Productcatalogus"]) {
       Productcataloog *p = [[Productcataloog alloc] init];
       p.categorieArray = [Brain brain].productCategorieArray;
       
       p.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
       [(UIViewController *)[self.superview nextResponder] presentModalViewController:p animated:YES];
       [p release];
   }
}

//1 module tonen
- (UIButton *)showModuleForIndex:(int)index {
    UIButton *btn = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
    NSDictionary *dict = [moduleArray objectAtIndex:index];
    
    btn.tag = index;
    btn.userInteractionEnabled = YES;
    
    [btn addTarget:self action:@selector(click:) forControlEvents:UIControlEventTouchUpInside];
    [btn setImage:[UIImage imageNamed:[dict objectForKey:@"imageURL"]] forState:UIControlStateNormal];
    
    return [btn autorelease];
}

//Modules tonen in scrollview
- (void)showModulesForIndex:(int)index forDirection:(NSString *)direction animated:(BOOL)animated {
    for (UIView *view in [[moduleScrollView.subviews copy] autorelease]) {
        [view removeFromSuperview];
    }
    
    if (index < 0) {
        currentPage = index + [moduleArray count];
    } else if (index>[moduleArray count]-1) {
        currentPage = index - [moduleArray count];
    } else {
        currentPage = index;
    }
    
    UIButton *btnFarLeft;
    if (currentPage < 2) {
        btnFarLeft = [[self showModuleForIndex:[moduleArray count]-2] retain];
    } else {
        btnFarLeft = [[self showModuleForIndex:currentPage-2] retain];
    }
    [moduleScrollView addSubview:btnFarLeft];
    
    UIButton *btnLeft;
    if (currentPage < 1) {
        btnLeft = [[self showModuleForIndex:[moduleArray count]-1] retain];
    } else {
        btnLeft = [[self showModuleForIndex:currentPage-1] retain];
    }
    [moduleScrollView addSubview:btnLeft];
    
    UIButton *btnMiddle = [[self showModuleForIndex:currentPage] retain];
    [moduleScrollView addSubview:btnMiddle];
    
    UIButton *btnRight;
    if (currentPage+1 > [moduleArray count]-1) {
        btnRight = [[self showModuleForIndex:0] retain];
    } else {
        btnRight = [[self showModuleForIndex:currentPage+1] retain];
    }
    [moduleScrollView addSubview:btnRight];
    
    UIButton *btnFarRight;
    if (currentPage+2 > [moduleArray count]-1) {
        btnFarRight = [[self showModuleForIndex:1] retain];
    } else {
        btnFarRight = [[self showModuleForIndex:currentPage+2] retain];
    }
    [moduleScrollView addSubview:btnFarRight];
    
    btnFarLeft.frame = CGRectMake(22+0*72, 15, 50, 50);
    btnLeft.frame = CGRectMake(22+1*72, 15, 50, 50);
    btnMiddle.frame = CGRectMake(22+2*72, 15, 50, 50);
    btnRight.frame = CGRectMake(22+3*72, 15, 50, 50);
    btnFarRight.frame = CGRectMake(22+4*72, 15, 50, 50);
    
    moduleScrollView.contentSize = CGSizeMake(72*5+22, moduleScrollView.frame.size.height);
    
    if ([direction isEqualToString:@"left"]) {
        [moduleScrollView setContentOffset:CGPointMake(0, 0) animated:NO];
    } else if ([direction isEqualToString:@"right"]) {
        [moduleScrollView setContentOffset:CGPointMake(2*72, 0) animated:NO];
    }
    
    [moduleScrollView setContentOffset:CGPointMake(1*72, 0) animated:animated];
    
    [btnFarLeft release];
    [btnLeft release];
    [btnMiddle release];
    [btnRight release];
    [btnFarRight release];
    
    [self changeLanguage];
}

//Change language
- (void)changeLanguage {
    module.text = [[moduleArray objectAtIndex:currentPage] valueForKey:[NSString stringWithFormat:@"titel%@",[Brain brain].currentLang]];
}

//Init scroll (modules toevoegen in array)
- (void)initScrollAnimated:(BOOL)animated {
    moduleArray = [[NSMutableArray alloc] initWithCapacity:4];
    
    NSMutableDictionary *toep = [[NSMutableDictionary alloc] init];
    [toep setObject:@"Toepassingmodule" forKey:@"titelNL"];
    [toep setObject:@"Module d'application" forKey:@"titelFR"];
    [toep setObject:@"toepassingen" forKey:@"imageURL"];
    [moduleArray insertObject:toep atIndex:0];
    [toep release];
    
    NSMutableDictionary *bere = [[NSMutableDictionary alloc] init];
    [bere setObject:@"Berekeningsmodule" forKey:@"titelNL"];
    [bere setObject:@"Module de calcul" forKey:@"titelFR"];
    [bere setObject:@"rekenmodule" forKey:@"imageURL"];
    [moduleArray insertObject:bere atIndex:1];
    [bere release];
    
    NSMutableDictionary *stor = [[NSMutableDictionary alloc] init];
    [stor setObject:@"Store Locator" forKey:@"titelNL"];
    [stor setObject:@"Store Locator" forKey:@"titelFR"];
    [stor setObject:@"storelocator" forKey:@"imageURL"];
    [moduleArray insertObject:stor atIndex:2];
    [stor release];
    
    NSMutableDictionary *prod = [[NSMutableDictionary alloc] init];
    [prod setObject:@"Productcatalogus" forKey:@"titelNL"];
    [prod setObject:@"Catalogue de produit" forKey:@"titelFR"];
    [prod setObject:@"productcatalogus" forKey:@"imageURL"];
    [moduleArray insertObject:prod atIndex:3];
    [prod release];
    
    [self showModulesForIndex:currentPage forDirection:nil animated:animated];
}

//Press left or right, or swipe
- (IBAction)pressLeft {
    [self showModulesForIndex:currentPage+1 forDirection:@"left" animated:YES];
}
- (IBAction)pressRight {
    [self showModulesForIndex:currentPage-1 forDirection:@"right" animated:YES];
}
- (void)swipeHandler:(UISwipeGestureRecognizer *)sender {
    if (sender.direction == UISwipeGestureRecognizerDirectionLeft) {
        [self showModulesForIndex:currentPage+1 forDirection:@"left" animated:YES];
    } else {
        [self showModulesForIndex:currentPage-1 forDirection:@"right" animated:YES];
    }
}

//Init met current index, toevoegen gesture recognizers
- (void)initWithIndex:(int)index animated:(BOOL)animated {
    currentPage = index;
    [self initScrollAnimated:animated];
    
    UIGestureRecognizer *swipeLeftRecognizer = [[UISwipeGestureRecognizer alloc] initWithTarget:self action:@selector(swipeHandler:)];
    [(UISwipeGestureRecognizer *)swipeLeftRecognizer setDirection:UISwipeGestureRecognizerDirectionLeft];
    [self addGestureRecognizer:swipeLeftRecognizer];
    [swipeLeftRecognizer release];
    
    UIGestureRecognizer *swipeRightRecognizer = [[UISwipeGestureRecognizer alloc] initWithTarget:self action:@selector(swipeHandler:)];
    [(UISwipeGestureRecognizer *)swipeRightRecognizer setDirection:UISwipeGestureRecognizerDirectionRight];
    [self addGestureRecognizer:swipeRightRecognizer];
    [swipeRightRecognizer release];
}

- (void)dealloc {
    [moduleArray release];
    
    [super dealloc];
}

@end
