//
//  PopoverInfo.m
//  Gyproc
//
//  Created by Bert Carrein on 24/05/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "PopoverInfo.h"
#import "Brain.h"


@implementation PopoverInfo

@synthesize titelLabel, textView, scroll;
@synthesize delegate;

//Init met stap
- (id)initWithStap:(Stap *)stap {
    self = [super init];
    if (self) {
        currentStap = [stap retain];
    }
    return self;
}

//Close popover
- (IBAction)close:(id)sender {
    [delegate closeInfoPopover];
}

//Load: inhoud weergeven van popover
- (void)viewDidLoad {
    [super viewDidLoad];
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        titelLabel.text = [NSString stringWithFormat:@"Tip bij stap %i",[currentStap.stap intValue]];
        textView.text = currentStap.tipNL;
    } else {
        titelLabel.text = [NSString stringWithFormat:@"Bon tuyau lors de l'étape %i",[currentStap.stap intValue]];
        textView.text = currentStap.tipFR;
    }
    
    [textView sizeToFit];
    scroll.contentSize = CGSizeMake(400, textView.frame.origin.y+textView.frame.size.height+20);
    
    if (textView.frame.origin.y+textView.frame.size.height+20<500) {
        self.contentSizeForViewInPopover = CGSizeMake(400, textView.frame.origin.y+textView.frame.size.height+20);
    } else {
        self.contentSizeForViewInPopover = CGSizeMake(400, 500);
    }
}

//Rotate
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}

- (void)dealloc {
    [currentStap release];
    [super dealloc];
}

@end
