//
//  PopoverWistjedat.m
//  Gyproc
//
//  Created by Bert Carrein on 24/05/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "PopoverWistjedat.h"
#import "Wistjedat.h"
#import "Toepassing.h"
#import "Brain.h"


@implementation PopoverWistjedat

@synthesize scroll, pageControl, titel;
@synthesize delegate;

//Init met toepassing
- (id)initWithToepassing:(Toepassing *)aToepassing {
    self = [super init];
    if (self) {
        currentToepassing = [aToepassing retain];
    }
    return self;
}

//pagecontroll goed zetten bij einde scroll
- (void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView {
    int stap = scroll.contentOffset.x/scroll.frame.size.width;
    pageControl.currentPage = stap;
}

//Load: inhoud weergeven
- (void)viewDidLoad {
    [super viewDidLoad];
    scroll.delegate = self;
    pageControl.numberOfPages = [currentToepassing.wistjedats count];
    
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        titel.text = @"Wist je dat?";
    } else {
        titel.text = @"Saviez-vous?";
    }
    
    int i = 0;
    for (Wistjedat *wjd in currentToepassing.wistjedats) {
        UILabel *text = [[UILabel alloc] initWithFrame:CGRectMake(20+i*40+i*310, 0, 310, 10)];
        text.numberOfLines = 0;
        text.backgroundColor = [UIColor clearColor];
        text.textColor = [UIColor whiteColor];
        text.font = [UIFont systemFontOfSize:14];
        
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            text.text = wjd.wjdNL;
        } else {
            text.text = wjd.wjdFR;
        }
        
        [text sizeToFit];
        [scroll addSubview:text];
        [text release];
        
        i++;
    }
    
    float height = 0;
    
    for (UIView *view in [[scroll.subviews copy] autorelease]) {
        if (height < view.frame.size.height) {
            height = view.frame.size.height;
        }
    }
    
    self.contentSizeForViewInPopover = CGSizeMake(350, height+10+pageControl.frame.size.height+scroll.frame.origin.y);
    scroll.contentSize = CGSizeMake(i*350, height);
}

//scroll naar volgende 'wist je dat' bij touch op pageControl
- (IBAction)pageControlChanged:(id)sender {
    [scroll scrollRectToVisible:CGRectMake(scroll.frame.size.width*pageControl.currentPage, 0, scroll.frame.size.width, scroll.frame.size.height) animated:YES];
}

//Close popover
- (IBAction)close:(id)sender {
    [delegate closeWistjedatPopover];
}

//Rotate
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}

- (void)viewDidUnload {
    [super viewDidUnload];
    
    scroll = nil;
    titel = nil;
    pageControl = nil;
}
- (void)dealloc {
    [currentToepassing release];
    [super dealloc];
}

@end
