//
//  ProductView.m
//  Gyproc
//
//  Created by Bert Carrein on 7/06/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "ProductView.h"
#import <QuartzCore/QuartzCore.h>
#import "Brain.h"


@implementation ProductView

@synthesize productLabel, imageView, product;
@synthesize delegate;
@synthesize delegateStart;
@synthesize selected;
@synthesize backgroundSelected, backgroundNotSelected, backgroundHighlighted;

//Touch op ProductView: product openen
- (void)hitView:(id)sender {
    [delegateStart kiesProduct:product];
    [delegate kiesProduct:product forOrientation:@"none"];
    
    for (ProductView *view in [[self.superview.subviews copy] autorelease]) {
        if ([view isKindOfClass:[ProductView class]]) {
            view.selected = NO;
        }
    }
    self.selected = YES;
}

//Init: backgrounds & inhoud
- (id)initWithFrame:(CGRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        //background
        backgroundSelected = [[UIImage imageNamed:@"toepassing-selected-bg.png"] retain];
        backgroundNotSelected = [[UIImage imageNamed:@"toepassing-notselected-bg.png"] retain];
        backgroundHighlighted = [[UIImage imageNamed:@"toepassing-hl-bg.png"] retain];
        
        //View van toepassing component in scrollview aanmaken
        productLabel = [[UILabel alloc] initWithFrame:CGRectMake(12, 92, frame.size.width-22, 50)];
        productLabel.backgroundColor = [UIColor clearColor];
        productLabel.font = [UIFont systemFontOfSize:14];
        productLabel.textColor = [UIColor colorWithRed:0.12 green:0.33 blue:0.6 alpha:1];
        productLabel.numberOfLines = 2;
        [self addSubview:productLabel];
        
        //Image init
        imageView = [[UIImageView alloc] initWithFrame:CGRectMake(12, 11, frame.size.width-24, 82)];
        imageView.layer.cornerRadius = 10;
        imageView.backgroundColor = [UIColor blackColor];
        imageView.clipsToBounds = YES;
        [self addSubview:imageView];
        
        self.selected = NO;
        [self setBackgroundImage:backgroundSelected forState:UIControlStateDisabled];
        [self setBackgroundImage:backgroundNotSelected forState:UIControlStateNormal];
        [self setBackgroundImage:backgroundHighlighted forState:UIControlStateHighlighted];
        
        [self addTarget:self action:@selector(hitView:) forControlEvents:UIControlEventTouchUpInside];
    }
    return self;
}

//ProductView selected (witte achtergrond)
- (void)setSelected:(BOOL)aBool {
    selected = aBool;
    
    if (aBool) {
        self.enabled = NO;
        productLabel.font = [UIFont boldSystemFontOfSize:14];
    } else {
        self.enabled = YES;
        productLabel.font = [UIFont systemFontOfSize:14];
    }
    imageView.alpha = 1;
}

//Inhoud in ProductView component invullen
- (void)setProduct:(Product *)aProduct {
    product = [aProduct retain];
    [self setLanguage];
    UIImage *img = [[UIImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:[NSString stringWithFormat:@"%@_t", product.productpicture] ofType:@"jpg"]];
    imageView.image = img;
    [img release];
}

//Set language
- (void)setLanguage {
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        productLabel.text = [NSString stringWithFormat:@"%@", product.titelNL];
    } else {
        productLabel.text = [NSString stringWithFormat:@"%@", product.titelFR];
    }
}

- (void)dealloc {
    [product release];
    [imageView release];
    [productLabel release];
    [backgroundSelected release];
    [backgroundNotSelected release];
    [backgroundHighlighted release];
    [super dealloc];
}

@end
