//
//  ProductenCategorieSwitchView.m
//  Gyproc
//
//  Created by Bert Carrein on 7/06/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "ProductenCategorieSwitchView.h"
#import "Brain.h"


@implementation ProductenCategorieSwitchView

@synthesize categorieLabel, countLabel;
@synthesize currentCategorie;
@synthesize delegate;
@synthesize currentIndex;

//Set GUI
- (void)setGUIForToepassing:(Product *)product {
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        categorieLabel.text = [[delegate.categorieArray objectAtIndex:currentIndex] titelNL];
    } else {
        categorieLabel.text = [[delegate.categorieArray objectAtIndex:currentIndex] titelFR];
    }
    
    countLabel.text = [NSString stringWithFormat:@"(%i/%i)",currentIndex+1,count];
    currentCategorie = [delegate.categorieArray objectAtIndex:currentIndex];
    
    [delegate toonProducten:currentCategorie forProduct:product forOrientation:@"none" justRotate:NO];
}

//init categorieswitch: currentindex & start categorie
- (void)initCategorieSwitch:(NSMutableArray *)anArray forStartCategorie:(ProductenCategorie *)start forProduct:(Product *)product {
    int i=0;
    for (ProductenCategorie *cat in delegate.categorieArray) {
        if (cat == start) {
            currentIndex = i;
        }
        i++;
    }
    
    count = [delegate.categorieArray count];
    [self setGUIForToepassing:product];
}

//Left & right press
- (IBAction)leftPressed:(id)sender {
    if (currentIndex>=1) {
        currentIndex--;
        [self setGUIForToepassing:nil];
    }
}
- (IBAction)rightPressed:(id)sender {
    if (currentIndex-1<count-2) {
        currentIndex++;
        [self setGUIForToepassing:nil];
    }
}

- (void)dealloc {
    [super dealloc];
}

@end