//
//  ProductenCategorie.m
//  Gyproc
//
//  Created by Bert Carrein on 30/05/11.
//  Copyright (c) 2011 DMS. All rights reserved.
//

#import "ProductenCategorie.h"


@implementation ProductenCategorie
@dynamic nodename;
@dynamic shortDescriptionFR;
@dynamic shortDescriptionNL;
@dynamic steppicture;
@dynamic titelNL;
@dynamic titelFR;
@dynamic products;
@dynamic categorieID;
@synthesize sortedProducts;

- (void)addProductsObject:(NSManagedObject *)value {    
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    [self willChangeValueForKey:@"products" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    [[self primitiveValueForKey:@"products"] addObject:value];
    [self didChangeValueForKey:@"products" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    [changedObjects release];
}

- (void)removeProductsObject:(NSManagedObject *)value {
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    [self willChangeValueForKey:@"products" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    [[self primitiveValueForKey:@"products"] removeObject:value];
    [self didChangeValueForKey:@"products" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    [changedObjects release];
}

- (void)addProducts:(NSSet *)value {    
    [self willChangeValueForKey:@"products" withSetMutation:NSKeyValueUnionSetMutation usingObjects:value];
    [[self primitiveValueForKey:@"products"] unionSet:value];
    [self didChangeValueForKey:@"products" withSetMutation:NSKeyValueUnionSetMutation usingObjects:value];
}

- (void)removeProducts:(NSSet *)value {
    [self willChangeValueForKey:@"products" withSetMutation:NSKeyValueMinusSetMutation usingObjects:value];
    [[self primitiveValueForKey:@"products"] minusSet:value];
    [self didChangeValueForKey:@"products" withSetMutation:NSKeyValueMinusSetMutation usingObjects:value];
}


@end
