//
//  Categorie.m
//  Gyproc
//
//  Created by Bert Carrein on 2/05/11.
//  Copyright (c) 2011 DMS. All rights reserved.
//

#import "ToepassingenCategorie.h"
#import "Toepassing.h"


@implementation ToepassingenCategorie
@dynamic titelNL;
@dynamic titelFR;
@dynamic toepassingen;
@dynamic categorieID;
@synthesize sortedToepassingen;

- (void)addToepassingenObject:(Toepassing *)value {    
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    [self willChangeValueForKey:@"toepassingen" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    [[self primitiveValueForKey:@"toepassingen"] addObject:value];
    [self didChangeValueForKey:@"toepassingen" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    [changedObjects release];
}

- (void)removeToepassingenObject:(Toepassing *)value {
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    [self willChangeValueForKey:@"toepassingen" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    [[self primitiveValueForKey:@"toepassingen"] removeObject:value];
    [self didChangeValueForKey:@"toepassingen" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    [changedObjects release];
}

- (void)addToepassingen:(NSSet *)value {    
    [self willChangeValueForKey:@"toepassingen" withSetMutation:NSKeyValueUnionSetMutation usingObjects:value];
    [[self primitiveValueForKey:@"toepassingen"] unionSet:value];
    [self didChangeValueForKey:@"toepassingen" withSetMutation:NSKeyValueUnionSetMutation usingObjects:value];
}

- (void)removeToepassingen:(NSSet *)value {
    [self willChangeValueForKey:@"toepassingen" withSetMutation:NSKeyValueMinusSetMutation usingObjects:value];
    [[self primitiveValueForKey:@"toepassingen"] minusSet:value];
    [self didChangeValueForKey:@"toepassingen" withSetMutation:NSKeyValueMinusSetMutation usingObjects:value];
}

- (void)dealloc {
    [sortedToepassingen release];
    [super dealloc];
}


@end
