//
//  ProductFotoView.m
//  Gyproc
//
//  Created by Bert Carrein on 9/06/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "ProductFotoView.h"


@implementation ProductFotoView

@synthesize delegate;

//Terugkeren naar ProductStartView
- (void)dismissController {
    [self dismissModalViewControllerAnimated:YES];
}
- (void)goBack:(UIGestureRecognizer *)sender {
    if ([sender isKindOfClass:[UITapGestureRecognizer class]] || [sender isKindOfClass:[UIPinchGestureRecognizer class]] && [(UIPinchGestureRecognizer *)sender scale] < 1) {
        if ([startOrientation isEqualToString:currentOrientation]) {
            [UIView beginAnimations:nil context:nil];
            [UIView setAnimationDuration:0.5];
            currentImage.center = oldImage.center;
            self.view.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:0];
            [UIView commitAnimations];
            
            [self performSelector:@selector(dismissController) withObject:nil afterDelay:0.5];
        } else {
            [self dismissController];
        }
    }
}

//Gesture recognizers toevoegen (zoom & double tap)
- (void)addGestureRecognizer {
    UIGestureRecognizer *tapRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(goBack:)];
    [(UITapGestureRecognizer *)tapRecognizer setNumberOfTapsRequired:2];
    [(UITapGestureRecognizer *)tapRecognizer setNumberOfTouchesRequired:1];
    [currentImage addGestureRecognizer:tapRecognizer];
    [tapRecognizer release];
    
    UIGestureRecognizer *pinchRecognizer = [[UIPinchGestureRecognizer alloc] initWithTarget:self action:@selector(goBack:)];
    [currentImage addGestureRecognizer:pinchRecognizer];
    [pinchRecognizer release];
}

//resize image
- (void)resizeImageForRectangle:(CGRect)aRect {
    float width = currentImage.bounds.size.width;
    float height = currentImage.bounds.size.height;
    
    if (width>aRect.size.width) {
        width = aRect.size.width;
        height = currentImage.frame.size.height/currentImage.frame.size.width*width;
    }
    if (height>aRect.size.height) {
        height = aRect.size.height;
        width = currentImage.frame.size.width/currentImage.frame.size.height*height;
    }
    
    currentImage.bounds = CGRectMake(0, 0, width, height);
}

//Foto tonen
- (void)showFirstPicture {
    float superWidth = 1024;
    float superHeight = 748;
    float xPos = 412;
    float yPos = 244;
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation)) {
        superWidth = 768;
        superHeight = 1004;
        xPos = 20;
        yPos = 465;
    }
    
    CGRect aRect = CGRectMake(xPos, yPos, superWidth, superHeight);
    
    currentImage = [[UIImageView alloc] initWithImage:oldImage.image];
    currentImage.center = oldImage.center;
    
    [self.view addSubview:currentImage];
    
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    oldImage.alpha = 1; 
    [UIView commitAnimations];
    
    float xCenterNew = aRect.size.width/2 - currentImage.frame.size.width/2;
    float yCenterNew = aRect.size.height/2 - currentImage.frame.size.height/2;
    
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    [UIView setAnimationDelay:0.5];
    currentImage.frame = CGRectMake(xCenterNew, yCenterNew, currentImage.frame.size.width, currentImage.frame.size.height);
    [UIView commitAnimations];
    
    currentImage.userInteractionEnabled = YES;
    [self addGestureRecognizer];
}

//init: foto doorgeven
- (id)initWithImageView:(UIImageView *)anOldImage {
    self = [super init];
    if (self) {
        self.view.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:0];
        
        [UIView beginAnimations:nil context:nil];
        [UIView setAnimationDuration:0.5];
        [UIView setAnimationDelay:0.5];
        self.view.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:1];
        [UIView commitAnimations];
        
        oldImage = [anOldImage retain];
        
        [self showFirstPicture];
        
        if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation)) {
            currentOrientation = [[NSString alloc] initWithString:@"Portrait"];
        } else {
            currentOrientation = [[NSString alloc] initWithString:@"Landscape"];
        }
        startOrientation = [currentOrientation retain];
    }
    return self;
}

//Gesture recognizer delegate
- (BOOL)gestureRecognizerShouldBegin:(UIGestureRecognizer *)gestureRecognizer {
    if ([gestureRecognizer.view isKindOfClass:[UIImage class]]) {
        return YES;
    }
    return NO;
}

//Rotate
- (void)willAnimateRotationToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration {
    float superWidth = 1024;
    float superHeight = 748;
    float xPos = 412;
    float yPos = 274;
    
    if (UIInterfaceOrientationIsPortrait(toInterfaceOrientation)) {
        superWidth = 768;
        superHeight = 1004;
        xPos = 20;
        yPos = 465;
        currentOrientation = @"Portrait";
    } else {
        currentOrientation = @"Landscape";
    }
    
    [self resizeImageForRectangle:CGRectMake(xPos, yPos, superWidth, superHeight)];
            
    float xCenterNew = superWidth/2;
    float yCenterNew = superHeight/2;
    currentImage.center = CGPointMake(xCenterNew, yCenterNew);
}
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}

- (void)viewDidLoad {
    [super viewDidLoad];
}
- (void)dealloc {
    [oldImage release];
    [currentImage release];
    [currentOrientation release];
    [startOrientation release];
    [super dealloc];
}

@end
