//
//  ProductStartView.h
//  Gyproc
//
//  Created by Bert Carrein on 7/06/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import <UIKit/UIKit.h>

#import "CataloogDelegate.h"
#import "Product.h"
#import "ProductenCategorie.h"
#import "ProductenCategorieSwitchView.h"
#import "ProductDelegate.h"
#import "LanguageDelegate.h"

//Controller 2e weergave productcataloog module: herin wordt een product (Product object) in detailweergave getoond
//De views die de kleine weergave van elk product controleert is van het type ProductView
//De view die zorgt voor de weergave van de categorieen is van het type ProductenCategorieSwitchView
@interface ProductStartView : UIViewController <ProductDelegate, UIGestureRecognizerDelegate> {
    NSString *previousSearchVar;
}

@property (nonatomic, retain) NSMutableArray *categorieArray;
@property (nonatomic, retain) NSMutableArray *productArray;
@property (nonatomic, retain) NSMutableArray *searchProductArray;

@property (nonatomic, retain) id<CataloogDelegate, ProductDelegate, LanguageDelegate> delegate;

@property (nonatomic, retain) ProductenCategorie *startCategorie;
@property (nonatomic) BOOL search;

@property (nonatomic, retain) IBOutlet UIScrollView *productScrollView;
@property (nonatomic, retain) IBOutlet ProductenCategorieSwitchView *categorieSwitch;
@property (nonatomic, retain) IBOutlet UIView *searchField;
@property (nonatomic, retain) IBOutlet UITextField *searchTextField;
@property (nonatomic, retain) IBOutlet UIButton *btnNL;
@property (nonatomic, retain) IBOutlet UIButton *btnFR;
@property (nonatomic, retain) IBOutlet UIButton *logoImage;
@property (nonatomic, retain) IBOutlet UILabel *geenResultaten;
@property (nonatomic, retain) IBOutlet UILabel *productTitel;
@property (nonatomic, retain) IBOutlet UIImageView *productFoto;

@property (nonatomic, retain) UIScrollView *productTekstScroll;
@property (nonatomic, retain) UILabel *productTekst;

@property (nonatomic, retain) Product *product;
@property (nonatomic, readonly, retain) ProductenCategorie *currentCategorie;

- (void)reposition:(NSString *)orientation;
- (void)toonProducten:(ProductenCategorie *)categorie forProduct:(Product *)product forOrientation:(NSString *)orientation justRotate:(BOOL)justRotate;
- (void)kiesProduct:(Product *)aProduct forOrientation:(NSString *)orientation;
- (void)setOrientation:(NSString *)orientation;
- (IBAction)setNL:(id)sender;
- (IBAction)setFR:(id)sender;
- (IBAction)goBackHome;

@end
