//
//  ProductStartView.m
//  Gyproc
//
//  Created by Bert Carrein on 7/06/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "ProductStartView.h"
#import "ProductView.h"
#import "ProductFotoView.h"
#import "Brain.h"


@implementation ProductStartView

@synthesize categorieArray,productArray;
@synthesize searchProductArray;
@synthesize delegate;
@synthesize geenResultaten;
@synthesize search;
@synthesize startCategorie;
@synthesize productScrollView,categorieSwitch;
@synthesize product;
@synthesize searchField,searchTextField;
@synthesize logoImage;
@synthesize btnNL,btnFR;
@synthesize currentCategorie;
@synthesize productTitel, productFoto, productTekst, productTekstScroll;

//producten toevoegen aan scrollview en geslecteerde in detailview tonen
- (void)productenWeergeven:(NSMutableArray *)producten forProduct:(Product *)aProduct forOrientation:(NSString *)orientation justRotate:(BOOL)justRotate {
    int counterX = 0;
    int counterY = 0;
    
    float paddingX = 6;
    int paddingY;
    
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation) && [orientation isEqualToString:@"none"] || [orientation isEqualToString:@"Portrait"]) {
        paddingY = 10;
    } else {
        paddingY = 9;
    }
    
    int width = 179;
    int height = 145;
    
    Product *prod2 = nil;
    for (Product *prod in producten) {
        ProductView *pv = [[ProductView alloc] initWithFrame:CGRectMake(paddingX + counterX*(width+paddingX), paddingY + counterY*(height+paddingY), width, height)];
        pv.delegate = self;
        pv.product = prod;
        
        [productScrollView addSubview:pv];
        [pv release];
        
        if (!search) {
            BOOL found = NO;
            if (aProduct == prod) {
                prod2 = [prod retain];
                
                pv.selected = YES;
                found = YES;
            }
            if (!aProduct && !found && counterX == 0 && counterY == 0) {
                prod2 = [prod retain];
                pv.selected = YES;
            }
        }
        
        if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation) && [orientation isEqualToString:@"none"] || [orientation isEqualToString:@"Portrait"]) {
            counterX++;
            counterY = 0;
        } else if (UIInterfaceOrientationIsLandscape(self.interfaceOrientation) && [orientation isEqualToString:@"none"] || [orientation isEqualToString:@"Landscape"]) {
            counterX++;
            if (counterX>=2) {
                counterX=0;
                counterY++;
            }
        }
    }
    
    if (justRotate) {
        prod2 = nil;
    }
    
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation) && [orientation isEqualToString:@"none"] || [orientation isEqualToString:@"Portrait"]) {
        productScrollView.contentSize = CGSizeMake([producten count]*(width+paddingX)+paddingX, height);
        if (prod2) {
            [self kiesProduct:prod2 forOrientation:@"Portrait"];
        }
    } else if (UIInterfaceOrientationIsLandscape(self.interfaceOrientation) && [orientation isEqualToString:@"none"] || [orientation isEqualToString:@"Landscape"]) {
        float count = [producten count];
        count = ceil(count/2);
        productScrollView.contentSize = CGSizeMake(productScrollView.frame.size.width, count*(height+paddingY)+paddingY);
        if (prod2) {
            [self kiesProduct:prod2 forOrientation:@"Landscape"];
        }
    }
    [prod2 release];
}

//Weergave van producten van gekozen categorie voorbereiden
- (void)toonProducten:(ProductenCategorie *)categorie forProduct:(Product *)aProduct forOrientation:(NSString *)orientation justRotate:(BOOL)justRotate {
    if (categorie != nil) {
        for (ProductenCategorie *cat in categorieArray) {
            if (cat == categorie) {
                self.productArray = [[cat.sortedProducts mutableCopy] autorelease];
            }
        }
        for (UIView *view in [[productScrollView.subviews copy] autorelease]) {
            if ([view isKindOfClass:[ProductView class]]) {
                [view removeFromSuperview];
            }
        }
        
        [self productenWeergeven:productArray forProduct:aProduct forOrientation:orientation justRotate:justRotate];
        searchTextField.text = @"";
    } else {
        for (UIView *view in [[productScrollView.subviews copy] autorelease]) {
            if ([view isKindOfClass:[ProductView class]]) {
                [view removeFromSuperview];
            }
        }
        if (searchProductArray != nil) {
            [self productenWeergeven:searchProductArray forProduct:nil forOrientation:orientation justRotate:justRotate];
        }
    }
}

//Search
- (void)searchFieldStartViewHit:(id)sender {
    NSString *searchVar = searchTextField.text;
    
    for (UIView *view in [[productScrollView.subviews copy] autorelease]) {
        if ([view isKindOfClass:[ProductView class]]) {
            [view removeFromSuperview];
        }
    }
    
    NSRange range1;
    NSRange range2;
    [searchProductArray release];
    searchProductArray = [[NSMutableArray alloc] init];
    
    for (Product *prod in productArray) {
        BOOL prodFound = NO;
        NSString *prodTitel = @"";
        NSString *prodTekst = @"";
        
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            prodTitel = [prod.titelNL lowercaseString];
            prodTekst = [prod.descriptionNL lowercaseString];
        } else {
            prodTitel = [prod.titelFR lowercaseString];
            prodTekst = [prod.descriptionFR lowercaseString];
        }
        
        range1 = [prodTitel rangeOfString:[searchVar lowercaseString]];
        range2 = [prodTekst rangeOfString:[searchVar lowercaseString]];
        if (range1.location != NSNotFound || range2.location != NSNotFound || prodFound) {
            [searchProductArray addObject:prod];
        }
    }
    
    if ([searchProductArray count]==0 && [searchTextField.text isEqualToString:@""]) {
        [self productenWeergeven:productArray forProduct:nil forOrientation:@"none" justRotate:NO];
        
        [UIView beginAnimations:nil context:nil];
        [UIView setAnimationDuration:0.3];
        geenResultaten.alpha = 0;
        [UIView commitAnimations];
    } else {
        [self productenWeergeven:searchProductArray forProduct:nil forOrientation:@"none" justRotate:NO];
        
        if ([searchProductArray count]==0) {
            [UIView beginAnimations:nil context:nil];
            [UIView setAnimationDuration:0.3];
            geenResultaten.alpha = 1;
            [UIView commitAnimations];
        } else {
            [UIView beginAnimations:nil context:nil];
            [UIView setAnimationDuration:0.3];
            geenResultaten.alpha = 0;
            [UIView commitAnimations];
        }
    }
}

//Search begin & exit
- (void)searchFieldStartViewBegin:(id)sender {
    search = YES;
    [self searchFieldStartViewHit:nil];
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    [UIView commitAnimations];
}
- (void)searchFieldStartViewExit:(id)sender {
    search = NO;
    BOOL found = NO;
    for (ProductView *tp in [[productScrollView.subviews copy] autorelease]) {
        if ([tp isKindOfClass:[ProductView class]]) {
            if (tp.selected) {
                [self kiesProduct:tp.product forOrientation:@"none"];
                found = YES;
            }
        }
    }
    
    if (!found) {
        int i=0;
        for (ProductView *tp in [[productScrollView.subviews copy] autorelease]) {
            if ([tp isKindOfClass:[ProductView class]]) {
                if (i==0) {
                    tp.selected = YES;
                    [self kiesProduct:tp.product forOrientation:@"none"];
                }
                i++;
            }
        }
    }
}

//TextView van product weergeven
- (void)setTextView {
    productTekst = [[UILabel alloc] init];
    productTekstScroll = [[UIScrollView alloc] init];
    
    productTekst.font = [UIFont systemFontOfSize:15];
    productTekst.textColor = [UIColor grayColor];
    productTekst.lineBreakMode = UILineBreakModeWordWrap;
    productTekst.numberOfLines = 0;
    productTekst.adjustsFontSizeToFitWidth = NO;
    productTekstScroll.showsVerticalScrollIndicator = YES;
    
    [productTekstScroll addSubview:productTekst];
    [self.view addSubview:productTekstScroll];
}

//double tap of zoom gesture op foto: ProductFotoView openen (foto in fullscreen)
- (void)tapMethod:(UIGestureRecognizer *)sender {
    if ([sender isKindOfClass:[UIGestureRecognizer class]]) {
        if ([sender.view isKindOfClass:[UIImageView class]]) {
            ProductFotoView *fotoView = [[ProductFotoView alloc] initWithImageView:(UIImageView *)sender.view];
            fotoView.delegate = self;
            self.modalPresentationStyle = UIModalPresentationCurrentContext;
            fotoView.modalTransitionStyle = UIModalTransitionStyleCrossDissolve;
            [self presentModalViewController:fotoView animated:NO];
            [fotoView release];
        }
    }
}

//Load: init categorieSwitch, talen, gesture recognizers toevoegen, productinfo tonen
- (void)viewDidLoad {
    [super viewDidLoad];
    
    [self setTextView];
    
    productFoto.contentMode = UIViewContentModeCenter;
    productFoto.backgroundColor = [UIColor lightGrayColor];
    
    UIGestureRecognizer *tapRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(tapMethod:)];
    [(UITapGestureRecognizer *)tapRecognizer setNumberOfTouchesRequired:1];
    [(UITapGestureRecognizer *)tapRecognizer setNumberOfTapsRequired:2];
    [productFoto addGestureRecognizer:tapRecognizer];
    tapRecognizer.delegate = self;
    [tapRecognizer release];
    
    UIGestureRecognizer *pinchRecognizer = [[UIPinchGestureRecognizer alloc] initWithTarget:self action:@selector(tapMethod:)];
    [productFoto addGestureRecognizer:pinchRecognizer];
    pinchRecognizer.delegate = self;
    [pinchRecognizer release];
    
    categorieSwitch.delegate = self;
    [categorieSwitch initCategorieSwitch:categorieArray forStartCategorie:self.startCategorie forProduct:product];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchFieldStartViewHit:) name:UITextFieldTextDidChangeNotification object:searchTextField];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchFieldStartViewBegin:) name:UITextFieldTextDidBeginEditingNotification object:searchTextField];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchFieldStartViewExit:) name:UITextFieldTextDidEndEditingNotification object:searchTextField];
    
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        btnNL.enabled = NO;
        btnFR.enabled = YES;
        searchTextField.placeholder = @"Zoek in producten...";
        geenResultaten.text = @"De zoekbewerking heeft geen overeenkomstige producten opgeleverd.";
    } else  {
        btnNL.enabled = YES;
        btnFR.enabled = NO;
        searchTextField.placeholder = @"Recherchez les produits...";
        geenResultaten.text = @"La recherche n'a pas produit des produits correspondantes.";
    }
}

//Rotate
- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration {
    if (toInterfaceOrientation == UIInterfaceOrientationLandscapeLeft || toInterfaceOrientation == UIInterfaceOrientationLandscapeRight) {
        [self reposition:@"Landscape"];
    } else {
        [self reposition:@"Portrait"];
    }
}
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}

//Set orientation: backgrounds
- (void)setOrientation:(NSString *)orientation {
    if ([orientation isEqualToString:@"Portrait"]) {
        self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg-p.jpg"]];
        categorieSwitch.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"categorie-zoek-bg-p.jpg"]];
        searchField.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"categorie-zoek-bg-p.jpg"]];
    } else {
        self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg-l.jpg"]];
        categorieSwitch.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"categorie-zoek-bg-p.jpg"]];
        searchField.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"categorie-zoek-bg-p.jpg"]];
    }
}

//Alle controls herpositioneren
- (void)reposition:(NSString *)orientation {
    if ([orientation isEqualToString:@"Landscape"]) {
        searchField.frame = CGRectMake(18, 185, 363, 41);
        categorieSwitch.frame = CGRectMake(18, 136, 363, 41);
        productScrollView.frame = CGRectMake(10.5, 246, 377, 471);
        logoImage.frame = CGRectMake(logoImage.frame.origin.x, 13, logoImage.frame.size.width, logoImage.frame.size.height);
        geenResultaten.frame = CGRectMake(30, 285, 357, 70);
        
        btnNL.frame = CGRectMake(btnNL.frame.origin.x , 54, btnNL.frame.size.width, btnNL.frame.size.height);
        btnFR.frame = CGRectMake(btnFR.frame.origin.x, 54, btnFR.frame.size.width, btnFR.frame.size.height);
        
        productFoto.frame = CGRectMake(412, 200, 591, 333);
        productTitel.frame = CGRectMake(412, 159, 591, 29);
        productTekstScroll.frame = CGRectMake(412, 543, 591, 176);
        productTekst.frame = CGRectMake(0, -3, 591, 140);
    } else {
        searchField.frame = CGRectMake(387, 135, 363, 41);
        categorieSwitch.frame = CGRectMake(18, 135, 363, 41);
        productScrollView.frame = CGRectMake(10, 189, 748, 165);
        logoImage.frame = CGRectMake(logoImage.frame.origin.x, 11, logoImage.frame.size.width, logoImage.frame.size.height);
        geenResultaten.frame = CGRectMake(170, 246, 427, 51);
        
        btnNL.frame = CGRectMake(btnNL.frame.origin.x ,50, btnNL.frame.size.width, btnNL.frame.size.height);
        btnFR.frame = CGRectMake(btnFR.frame.origin.x, 50, btnFR.frame.size.width, btnFR.frame.size.height);
        
        productFoto.frame = CGRectMake(20, 425, 728, 410);
        productTitel.frame = CGRectMake(20, 384, 728, 29);
        productTekstScroll.frame = CGRectMake(20, 845, 728, 143);
        productTekst.frame = CGRectMake(0, -3, 728, 110);
    }
    
    [productTekst sizeToFit];
    productTekstScroll.contentSize = CGSizeMake(productTekstScroll.frame.size.width, productTekst.frame.size.height-3);
    
    if (search) {
        [self toonProducten:nil forProduct:nil forOrientation:orientation justRotate:YES];
    } else {
        [self toonProducten:[categorieArray objectAtIndex:categorieSwitch.currentIndex] forProduct:product forOrientation:orientation justRotate:YES];
    }
    
    [self setOrientation:orientation];
}

//Verander taal delegate + categorieSwitch init
- (void)veranderTaal {
    [delegate changeLanguage];
    [categorieSwitch initCategorieSwitch:categorieArray forStartCategorie:categorieSwitch.currentCategorie forProduct:product];
}
- (IBAction)setNL:(id)sender {
    if (btnNL.enabled) {
        btnNL.enabled = NO;
        btnFR.enabled = YES;
        
        [Brain brain].currentLang = @"NL";
        searchTextField.placeholder = @"Zoek in producten...";
        geenResultaten.text = @"De zoekbewerking heeft geen overeenkomstige producten opgeleverd.";
        
        [self veranderTaal];
    }
}
- (IBAction)setFR:(id)sender {
    if (btnFR.enabled) {
        btnNL.enabled = YES;
        btnFR.enabled = NO;
        
        [Brain brain].currentLang = @"FR";
        searchTextField.placeholder = @"Recherchez les applications...";
        geenResultaten.text = @"La recherche n'a pas produit de produits correspondantes.";
        
        [self veranderTaal];
    }
}

//Terugkeren naar Productcataloog Controller
- (IBAction)goBackHome {
    self.categorieSwitch.currentCategorie = nil;
    self.product = nil;
    
    [self dismissModalViewControllerAnimated:YES];
}

//Informatie van Product tonen
- (void)kiesProduct:(Product *)aProduct forOrientation:(NSString *)orientation {
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        productTitel.text = aProduct.titelNL;
        productTekst.text = aProduct.descriptionNL;
    } else {
        productTitel.text = aProduct.titelFR;
        productTekst.text = aProduct.descriptionFR;
    }
    
    if ([orientation isEqualToString:@"Portrait"]) {
        productTekst.frame = CGRectMake(0, -3, 728, 110);
    } else {
        productTekst.frame = CGRectMake(0, -3, 591, 140);
    }
    
    UIImage *img = [[UIImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:[NSString stringWithFormat:@"%@", aProduct.productpicture] ofType:@"jpg"]];
    productFoto.image = img;
    [img release];
    
    [productTekst sizeToFit];
    productTekstScroll.contentSize = CGSizeMake(productTekstScroll.frame.size.width, productTekst.frame.size.height-3);
}

//Gesturerecognizer delegate method
- (BOOL)gestureRecognizer:(UIGestureRecognizer *)gestureRecognizer shouldReceiveTouch:(UITouch *)touch {
    return YES;
}

- (ProductenCategorie *)currentCategorie {
    return categorieSwitch.currentCategorie;
}
- (void)viewDidUnload {
    [super viewDidUnload];
    self.productScrollView = nil;
    self.categorieSwitch = nil;
    self.searchTextField = nil;
    self.searchField = nil;
    self.btnFR = nil;
    self.btnNL = nil;
    self.logoImage = nil;
    self.geenResultaten = nil;
    self.productTitel = nil;
    self.productFoto = nil;
}
- (void)dealloc {
    [product release];
    [productTekst release];
    [productTekstScroll release];
    [currentCategorie release];
    [categorieArray release];
    [productArray release];
    [searchProductArray release];
    [delegate release];
    [productScrollView release];
    
    [super dealloc];
}

@end
