//
//  Productcataloog.h
//  Gyproc
//
//  Created by Bert Carrein on 7/06/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import <UIKit/UIKit.h>

#import "ProductenCategorie.h"
#import "CataloogDelegate.h"
#import "ProductView.h"
#import "ModuleSwitch.h"
#import "LanguageDelegate.h"

//Controller 1e view productcataloog module: hierin worden alle categorieen van de producten getoond (ProductenCategorie object)
//De views die de kleine weergave van elk product controleert is van het type ProductView (enkel te zien in landscape mode)
@interface Productcataloog : UIViewController <CataloogDelegate, ProductDelegate, LanguageDelegate> {
    BOOL search;
}

@property (nonatomic, retain) NSManagedObjectContext *managedObjectContext;
@property (nonatomic, retain) NSMutableArray *categorieArray;
@property (nonatomic, retain) NSMutableArray *productArray;
@property (nonatomic, retain) NSMutableArray *searchCategorieArray;

@property (nonatomic, retain) ProductenCategorie *currentCategorie;

@property (nonatomic, retain) IBOutlet UIView *searchFieldStart;
@property (nonatomic, retain) IBOutlet UITextField *searchTextFieldStart;
@property (nonatomic, retain) IBOutlet UILabel *startTitel;
@property (nonatomic, retain) IBOutlet UIScrollView *categorieScrollView;
@property (nonatomic, retain) IBOutlet UIButton *btnNL;
@property (nonatomic, retain) IBOutlet UIButton *btnFR;
@property (nonatomic, retain) IBOutlet UIScrollView *productScrollView;
@property (nonatomic, retain) IBOutlet UIButton *logoImage;
@property (nonatomic, retain) IBOutlet UILabel *categorieTitel;
@property (nonatomic, retain) IBOutlet UILabel *aantalProducten;
@property (nonatomic, retain) IBOutlet UILabel *geenResultaten;

@property (nonatomic, retain) IBOutlet ModuleSwitch *moduleSwitch;

- (void)toonCategorieen:(NSMutableArray *)arr searchNothingFound:(BOOL)nothingFound;
- (void)toonProductenForCategorie:(ProductenCategorie *)chosenCategorie;

- (IBAction)setNL:(id)sender;
- (IBAction)setFR:(id)sender;
- (IBAction)openCategorie:(UIButton *)sender;

@end
