//
//  Productcataloog.m
//  Gyproc
//
//  Created by Bert Carrein on 7/06/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "Productcataloog.h"

#import "Product.h"
#import "ProductStartView.h"
#import "Brain.h"


@implementation Productcataloog

@synthesize categorieArray;
@synthesize productArray;
@synthesize searchCategorieArray;
@synthesize currentCategorie;
@synthesize managedObjectContext;
@synthesize btnNL, btnFR;
@synthesize searchFieldStart, searchTextFieldStart;
@synthesize startTitel;
@synthesize categorieScrollView;
@synthesize productScrollView;
@synthesize logoImage;
@synthesize categorieTitel;
@synthesize aantalProducten;
@synthesize geenResultaten;
@synthesize moduleSwitch;

//Categorie ophalen die bij button hoort
- (ProductenCategorie *)getCategorieForButton:(UIButton *)sender OrCount:(int)count {
    for (ProductenCategorie *cat in self.categorieArray) {
        BOOL found = NO;
        int teller = 0;
        if (sender) {
            for (UILabel *lbl in [[sender.subviews copy] autorelease]) {
                if ([lbl isKindOfClass:[UILabel class]]) {
                    if ([[Brain brain].currentLang isEqualToString:@"NL"] && [lbl.text isEqualToString:cat.titelNL] || [[Brain brain].currentLang isEqualToString:@"FR"] && [lbl.text isEqualToString:cat.titelFR]) {
                        return cat;
                    }
                }
            }
        } else {
            for (UIButton *btn in [[categorieScrollView.subviews copy] autorelease]) {
                if ([btn isKindOfClass:[UIButton class]] && teller==count) {
                    for (UILabel *lbl in [[btn.subviews copy] autorelease]) {
                        if ([lbl isKindOfClass:[UILabel class]]) {
                            if ([[Brain brain].currentLang isEqualToString:@"NL"] && [lbl.text isEqualToString:cat.titelNL] || [[Brain brain].currentLang isEqualToString:@"FR"] && [lbl.text isEqualToString:cat.titelFR]) {
                                return cat;
                            }
                        }
                    }
                    teller++;
                }
            }
        }
        
        if (found) {
            return cat;
        }
    }
    return nil;
}

//Search
- (void)searchFieldStartHit:(id)sender {
    for (UIView *view in [[[categorieScrollView subviews] copy] autorelease]) {
        if ([view isKindOfClass:[UIButton class]]) {
            [view removeFromSuperview];
        }
    }
    NSString *searchVar = [searchTextFieldStart.text lowercaseString];
    NSRange range1;
    NSRange range2;
    NSRange range3;
    [searchCategorieArray release];
    searchCategorieArray = [[NSMutableArray alloc] init];
    
    for (ProductenCategorie *cat in categorieArray) {
        BOOL toepFound = NO;
        NSString *catTitel = @"";
        
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            catTitel = [cat.titelNL lowercaseString];
        } else {
            catTitel = [cat.titelFR lowercaseString];
        }
        
        range1 = [catTitel rangeOfString:searchVar];
        
        for (Product *toep in cat.sortedProducts) {
            NSString *toepTitel = @"";
            NSString *toepTekst = @"";
            
            if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
                toepTitel = [toep.titelNL lowercaseString];
                toepTekst = [toep.descriptionNL lowercaseString];
            } else {
                toepTitel = [toep.titelFR lowercaseString];
                toepTekst = [toep.descriptionFR lowercaseString];
            }
            
            range2 = [toepTitel rangeOfString:searchVar];
            range3 = [toepTekst rangeOfString:searchVar];
            
            if (range2.location != NSNotFound || range3.location != NSNotFound) {
                toepFound = YES;
            }
        }
        
        if (range1.location != NSNotFound || toepFound) {
            [searchCategorieArray addObject:cat];
        }
    }
    
    if ([searchCategorieArray count]==0 && [searchTextFieldStart.text isEqualToString:@""]) {
        [self toonCategorieen:categorieArray searchNothingFound:YES];
        
        [UIView beginAnimations:nil context:nil];
        [UIView setAnimationDuration:0.3];
        geenResultaten.alpha = 0;
        [UIView commitAnimations];
    } else {
        [self toonCategorieen:searchCategorieArray searchNothingFound:NO];
        
        if ([searchCategorieArray count]==0) {
            for (ProductView *pv in [[productScrollView.subviews copy] autorelease]) {
                if ([pv isKindOfClass:[ProductView class]]) {
                    [pv removeFromSuperview];
                }
            }
            
            [UIView beginAnimations:nil context:nil];
            [UIView setAnimationDuration:0.3];
            geenResultaten.alpha = 1;
            [UIView commitAnimations];
            
            if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
                categorieTitel.text = @"Geen categorieën en producten gevonden";
            } else {
                categorieTitel.text = @"Pas de catégories et produits";
            }
        } else {
            [UIView beginAnimations:nil context:nil];
            [UIView setAnimationDuration:0.3];
            geenResultaten.alpha = 0;
            [UIView commitAnimations];
        }
    }
}

//Search begin & exit
- (void)searchFieldStartBegin:(id)sender {
    search = YES;
}
- (void)searchFieldStartExit:(id)sender {
    search = NO;
}

//Set orientation: posities & backgrounds
- (void)setOrientation:(NSString *)orientation {
    if ([orientation isEqualToString:@"Portrait"]) {
        self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg-start-p.jpg"]];
        searchFieldStart.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"start-zoek-bg-p.jpg"]];
        
        categorieScrollView.frame = CGRectMake(90, 210, 588, 746);
        
        for (UIButton *btn in [[categorieScrollView.subviews copy] autorelease]) {
            if ([btn isKindOfClass:[UIButton class]]) {
                btn.frame = CGRectMake(btn.frame.origin.x, btn.frame.origin.y, 526, btn.frame.size.height);
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-notselected-p.png"] forState:UIControlStateNormal];
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-hl-p.png"] forState:UIControlStateHighlighted];
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-selected-p.png"] forState:UIControlStateDisabled];
                btn.enabled = YES;
            }
        }
        
        btnNL.frame = CGRectMake(581, 56, btnNL.frame.size.width, btnNL.frame.size.height);
        btnFR.frame = CGRectMake(634, 56, btnFR.frame.size.width, btnFR.frame.size.height);
        
        searchFieldStart.frame = CGRectMake(396, 148, 250, 41);
        startTitel.frame = CGRectMake(123, 159, startTitel.frame.size.width, startTitel.frame.size.height);
        logoImage.frame = CGRectMake(85, logoImage.frame.origin.y, logoImage.frame.size.width, logoImage.frame.size.height);
        geenResultaten.frame = CGRectMake(173, 377, 422, 51);
        moduleSwitch.frame = CGRectMake(296, 0, moduleSwitch.frame.size.width, moduleSwitch.frame.size.height);
        
        productScrollView.hidden = YES;
        categorieTitel.hidden = YES;
        aantalProducten.hidden = YES;
    } else {
        self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg-start-l.jpg"]];
        searchFieldStart.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"start-zoek-bg-l.jpg"]];
        categorieScrollView.frame = CGRectMake(11, 246, 423, 471);
        
        int i = 0;
        for (UIButton *btn in [[categorieScrollView.subviews copy] autorelease]) {
            if ([btn isKindOfClass:[UIButton class]]) {
                btn.frame = CGRectMake(btn.frame.origin.x, btn.frame.origin.y, 360, btn.frame.size.height);
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-notselected-l.png"] forState:UIControlStateNormal];
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-hl-l.png"] forState:UIControlStateHighlighted];
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-selected-l.png"] forState:UIControlStateDisabled];
                
                if (i==0) {
                    btn.enabled = NO;
                    [self toonProductenForCategorie:[categorieArray objectAtIndex:0]];
                } else {
                    btn.enabled = YES;
                }
                i++;
            }
        }
        
        btnNL.frame = CGRectMake(910, 54, btnNL.frame.size.width, btnNL.frame.size.height);
        btnFR.frame = CGRectMake(963, 54, btnFR.frame.size.width, btnFR.frame.size.height);
        
        searchFieldStart.frame = CGRectMake(42, 185, 360, 41);
        startTitel.frame = CGRectMake(43, 138, startTitel.frame.size.width, startTitel.frame.size.height);
        logoImage.frame = CGRectMake(8, logoImage.frame.origin.y, logoImage.frame.size.width, logoImage.frame.size.height);
        geenResultaten.frame = CGRectMake(31, 290, 383, 51);
        moduleSwitch.frame = CGRectMake(445, 0, moduleSwitch.frame.size.width, moduleSwitch.frame.size.height);
        
        productScrollView.hidden = NO;
        categorieTitel.hidden = NO;
        aantalProducten.hidden = NO;
    }
}

//Producten van de categorie weergeven (enkel te zien in landscape mode)
- (void)toonProductenForCategorie:(ProductenCategorie *)chosenCategorie {
    self.currentCategorie = chosenCategorie;
    
    for (ProductenCategorie *cat in categorieArray) {
        if (cat == currentCategorie) {
            self.productArray = [[cat.sortedProducts mutableCopy] autorelease];
        }
    }
    
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        categorieTitel.text = currentCategorie.titelNL;
        aantalProducten.text = [NSString stringWithFormat:@"%i producten",[currentCategorie.sortedProducts count]];
    } else {
        categorieTitel.text = currentCategorie.titelFR;
        aantalProducten.text = [NSString stringWithFormat:@"%i produits",[currentCategorie.sortedProducts count]];
    }
    
    for (UIView *view in [[[productScrollView subviews] copy] autorelease]) {
        if ([view isKindOfClass:[ProductView class]]) {
            [view removeFromSuperview];
        }
    }
    
    int counterX = 0;
    int counterY = 0;
    
    float paddingX = 6;
    int paddingY = 9;
    
    int width = 179;
    int height = 145;
    
    for (Product *product in productArray) {
        ProductView *pv = [[ProductView alloc] initWithFrame:CGRectMake(paddingX + counterX*(width+paddingX), paddingY + counterY*(height+paddingY), width, height)];
        pv.delegateStart = self;
        pv.product = product;
        
        [productScrollView addSubview:pv];
        [pv release];
        
        counterX++;
        if (counterX>=3) {
            counterX=0;
            counterY++;
        }
    }
    
    float count = [productArray count];
    count = ceil(count/3);
    productScrollView.contentSize = CGSizeMake(productScrollView.frame.size.width, count*(height+paddingY)+paddingY);
}

//Categorieen tonen in scrollview
- (void)toonCategorieen:(NSMutableArray *)arr searchNothingFound:(BOOL)nothingFound {
    for (UIButton *cat in [[categorieScrollView.subviews copy] autorelease]) {
        if ([cat isKindOfClass:[UIButton class]]) {
            [cat removeFromSuperview];
        }
    }
    
    int i = 0;
    int height = 63;
    int width = 526;
    int padding = 20;
    
    for (ProductenCategorie *cat in arr) {
        UIButton *btn = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
        [btn addTarget:self action:@selector(openCategorie:) forControlEvents:UIControlEventTouchUpInside];
        btn.frame = CGRectMake(31, 31+i*(padding+height), width, height);
        btn.titleLabel.textAlignment = UITextAlignmentLeft;
        btn.tag = i;
        
        if (i==0) {
            btn.enabled = NO;
        }
        
        UILabel *lblTitel = [[UILabel alloc] initWithFrame:CGRectMake(15, 12, 300, 20)];
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            lblTitel.text = [cat valueForKey:@"titelNL"];
        } else {
            lblTitel.text = [cat valueForKey:@"titelFR"];
        }
        btn.userInteractionEnabled = YES;
        
        lblTitel.textColor = [UIColor colorWithRed:0.211 green:0.371 blue:0.648 alpha:1];
        lblTitel.font = [UIFont boldSystemFontOfSize:17];
        lblTitel.backgroundColor = [UIColor clearColor];
        [btn addSubview:lblTitel];
        [lblTitel release];
        
        UILabel *lblProducten = [[UILabel alloc] initWithFrame:CGRectMake(15, 32, 300, 20)];
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            lblProducten.text = [NSString stringWithFormat:@"%i producten",[[cat valueForKey:@"sortedProducts"] count]];
        } else {
            lblProducten.text = [NSString stringWithFormat:@"%i produits",[[cat valueForKey:@"sortedProducts"] count]];
        }
        
        lblProducten.textColor = [UIColor colorWithRed:0.211 green:0.371 blue:0.648 alpha:1];
        lblProducten.font = [UIFont systemFontOfSize:12];
        lblProducten.backgroundColor = [UIColor clearColor];
        [btn addSubview:lblProducten];
        [lblProducten release];
        
        [categorieScrollView addSubview:btn];
        
        [btn release];
        i++;
    }
    
    categorieScrollView.contentSize = CGSizeMake(categorieScrollView.frame.size.width, 62+([arr count])*(padding+height)-padding);
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation)) {
        [self setOrientation:@"Portrait"];
    } else {
        [self setOrientation:@"Landscape"];
        [self toonProductenForCategorie:[self getCategorieForButton:nil OrCount:0]];
    }
}

//Load: init moduleswitch, init search, talen, orientatie
- (void)viewDidLoad {
    [super viewDidLoad];
    
    [moduleSwitch initWithIndex:3 animated:NO];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchFieldStartHit:) name:UITextFieldTextDidChangeNotification object:searchTextFieldStart];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchFieldStartBegin:) name:UITextFieldTextDidBeginEditingNotification object:searchTextFieldStart];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchFieldStartExit:) name:UITextFieldTextDidEndEditingNotification object:searchTextFieldStart];
    
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        [self setNL:nil];
    } else {
        [self setFR:nil];
    }
    
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation)) {
        [self setOrientation:@"Portrait"];
    } else {
        [self setOrientation:@"Landscape"];
    }
}

//Rotate
- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration {
    if (UIInterfaceOrientationIsPortrait(toInterfaceOrientation)) {
        [self setOrientation:@"Portrait"];
    } else {
        [self setOrientation:@"Landscape"];
    }
    
    categorieScrollView.contentSize = CGSizeMake(categorieScrollView.frame.size.width, categorieScrollView.contentSize.height);
}
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}

//Verander taal: moduleswitch, toon categorieen, search
- (void)veranderTaal {
    [moduleSwitch changeLanguage];
    [self toonCategorieen:categorieArray searchNothingFound:NO];
    searchTextFieldStart.text = @"";
    if (search) {
        [self searchFieldStartHit:nil];
    }
}
- (IBAction)setNL:(id)sender {
    btnNL.enabled = NO;
    btnFR.enabled = YES;
    
    [Brain brain].currentLang = @"NL";
    searchTextFieldStart.placeholder = @"Zoeken...";
    startTitel.text = [NSString stringWithFormat:@"Productcatalogus", [categorieArray count]];
    geenResultaten.text = @"De zoekbewerking heeft geen overeenkomstige categorieën opgeleverd.";
    
    [self veranderTaal];
}
- (IBAction)setFR:(id)sender {
    btnNL.enabled = YES;
    btnFR.enabled = NO;
    
    [Brain brain].currentLang = @"FR";
    searchTextFieldStart.placeholder = @"Rechercher...";
    startTitel.text = [NSString stringWithFormat:@"Catalogue de produit", [categorieArray count]];
    geenResultaten.text = @"La recherche n'a pas produit de catégories correspondantes.";
    
    [self veranderTaal];
}

//Delegate method
- (void)changeLanguage {
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        [self setNL:nil];
    } else {
        [self setFR:nil];
    }
}

//Klikken op een categorie: in portrait ProductStartView tonen, anders producten weergeven van de gekozen categorie
- (IBAction)openCategorie:(UIButton *)sender {
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation)) {
        if (search) {
            [searchTextFieldStart resignFirstResponder];
        }
        ProductStartView *sv =  [[ProductStartView alloc] init];
        sv.delegate = self;
        sv.startCategorie = [self getCategorieForButton:sender OrCount:0];
        sv.categorieArray = self.categorieArray;
        sv.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
        [self presentModalViewController:sv animated:YES];
        [sv release];
    } else {
        for (UIButton *btn in [[categorieScrollView.subviews copy] autorelease]) {
            if ([btn isKindOfClass:[UIButton class]]) {
                btn.enabled = YES;
            }
        }
        
        [self toonProductenForCategorie:[self getCategorieForButton:sender OrCount:0]];
        sender.enabled = NO;
    }
}

//Klikken op product (kan enkel in landscape mode): ProductStartView openen
- (void)kiesProduct:(Product *)aProduct {
    for (ProductView *pv in [[productScrollView.subviews copy] autorelease]) {
        if ([pv isKindOfClass:[ProductView class]]) {
            pv.selected = NO;
        }
    }
    
    if (search) {
        [searchTextFieldStart resignFirstResponder];
    }
    
    ProductStartView *sv =  [[ProductStartView alloc] init];
    sv.delegate = self;
    sv.startCategorie = currentCategorie;
    sv.categorieArray = self.categorieArray;
    sv.product = aProduct;
    sv.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
    [self presentModalViewController:sv animated:YES];
    [sv release];
}

//View did appear: init moduleSwitch (is nodig als men terugkeert van Store Locator)
- (void)viewDidAppear:(BOOL)animated {
    [moduleSwitch initWithIndex:3 animated:NO];
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    searchFieldStart = nil;
    searchTextFieldStart = nil;
    startTitel = nil;
    categorieScrollView = nil;
    btnNL = nil;
    btnFR = nil;
    productScrollView = nil;
    logoImage = nil;
    categorieTitel = nil;
    aantalProducten = nil;
    geenResultaten = nil;
    moduleSwitch = nil;
}
- (void)dealloc {
    [managedObjectContext release];
    [currentCategorie release];
    [categorieArray release];
    [productArray release];
    [searchCategorieArray release];
    [super dealloc];
}

//Delegate methods (optional)
//- (void)kiesProduct:(Product *)aProduct forOrientation:(NSString *)orientation{}
//- (void)toonProducten:(ProductenCategorie *)categorie forProduct:(Product *)product forOrientation:(NSString *)orientation justRotate:(BOOL)justRotate{}

@end
