//
//  Start.h
//  Gyproc
//
//  Created by Bert Carrein on 5/05/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import <UIKit/UIKit.h>

#import "ToepassingenCategorie.h"
#import "Toepassing.h"
#import "Stap.h"
#import "StartView.h"
#import "StartDelegate.h"
#import "GANTracker.h"
#import "ModuleSwitch.h"
#import "Brain.h"
#import "LanguageDelegate.h"

//Controller 1e view Toepassingmodule. Alle categorieen van de toepassingen (ToepassingenCategorie object) worden hierin weergegeven.
//De views die de kleine weergave van elke toepassing controleert is van het type ToepassingView (enkel te zien in landscape mode)
@interface Start : UIViewController <StartDelegate, LanguageDelegate> {
    BOOL search;
}

@property (nonatomic, retain) NSManagedObjectContext *managedObjectContext;
@property (nonatomic, retain) NSMutableArray *categorieArray;
@property (nonatomic, retain) NSMutableArray *searchCategorieArray;
@property (nonatomic, retain) NSMutableArray *searchToepassingArray;
@property (nonatomic, retain) NSMutableArray *toepassingArray;

@property (nonatomic, retain) ToepassingenCategorie *currentCategorie;

@property (nonatomic, retain) IBOutlet UIView *searchFieldStart;
@property (nonatomic, retain) IBOutlet UITextField *searchTextFieldStart;
@property (nonatomic, retain) IBOutlet UILabel *startTitel;
@property (nonatomic, retain) IBOutlet UIScrollView *categorieScrollView;
@property (nonatomic, retain) IBOutlet UIButton *btnNL;
@property (nonatomic, retain) IBOutlet UIButton *btnFR;
@property (nonatomic, retain) IBOutlet UIScrollView *toepassingScrollView;
@property (nonatomic, retain) IBOutlet UIButton *logoImage;
@property (nonatomic, retain) IBOutlet UILabel *categorieTitel;
@property (nonatomic, retain) IBOutlet UILabel *aantalToep;
@property (nonatomic, retain) IBOutlet UILabel *geenResultaten;

@property (nonatomic, retain) IBOutlet ModuleSwitch *moduleSwitch;

- (void)toonCategorieen:(NSMutableArray *)arr searchNothingFound:(BOOL)nothingFound;
- (void)toonToepassingenForCategorie:(ToepassingenCategorie *)chosenCategorie;

- (IBAction)setNL:(id)sender;
- (IBAction)setFR:(id)sender;
- (IBAction)openCategorie:(UIButton *)sender;

@end
