//
//  Start.m
//  Gyproc
//
//  Created by Bert Carrein on 5/05/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "Start.h"


@implementation Start

@synthesize categorieArray;
@synthesize searchCategorieArray,searchToepassingArray;
@synthesize managedObjectContext;
@synthesize searchFieldStart,searchTextFieldStart;
@synthesize startTitel,categorieScrollView;
@synthesize logoImage;
@synthesize toepassingScrollView;
@synthesize btnNL,btnFR;
@synthesize currentCategorie;
@synthesize toepassingArray;
@synthesize aantalToep,categorieTitel;
@synthesize geenResultaten;
@synthesize moduleSwitch;

//Categorie ophalen die bij de button hoort
- (ToepassingenCategorie *)getCategorieForButton:(UIButton *)sender OrCount:(int)count {
    for (ToepassingenCategorie *cat in self.categorieArray) {
        BOOL found = NO;
        int teller = 0;
        if (sender) {
            for (UILabel *lbl in [[sender.subviews copy] autorelease]) {
                if ([lbl isKindOfClass:[UILabel class]]) {
                    if ([[Brain brain].currentLang isEqualToString:@"NL"] && [lbl.text isEqualToString:cat.titelNL] || [[Brain brain].currentLang isEqualToString:@"FR"] && [lbl.text isEqualToString:cat.titelFR]) {
                        return cat;
                    }
                }
            }
        } else {
            for (UIButton *btn in [[categorieScrollView.subviews copy] autorelease]) {
                if ([btn isKindOfClass:[UIButton class]] && teller==count) {
                    for (UILabel *lbl in [[btn.subviews copy] autorelease]) {
                        if ([lbl isKindOfClass:[UILabel class]]) {
                            if ([[Brain brain].currentLang isEqualToString:@"NL"] && [lbl.text isEqualToString:cat.titelNL] || [[Brain brain].currentLang isEqualToString:@"FR"] && [lbl.text isEqualToString:cat.titelFR]) {
                                return cat;
                            }
                        }
                    }
                    teller++;
                }
            }
        }
        
        if (found) {
            return cat;
        }
    }
    return nil;
}

//Search
- (void)searchFieldStartHit:(id)sender {
    for (UIView *view in [[[categorieScrollView subviews] copy] autorelease]) {
        if ([view isKindOfClass:[UIButton class]]) {
            [view removeFromSuperview];
        }
    }
    NSString *searchVar = [searchTextFieldStart.text lowercaseString];
    NSRange range1;
    NSRange range2;
    NSRange range3;
    [searchCategorieArray release];
    searchCategorieArray = [[NSMutableArray alloc] init];
    
    for (ToepassingenCategorie *cat in categorieArray) {
        BOOL toepFound = NO;
        NSString *catTitel = @"";
        
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            catTitel = [cat.titelNL lowercaseString];
        } else {
            catTitel = [cat.titelFR lowercaseString];
        }
        
        range1 = [catTitel rangeOfString:searchVar];
        
        for (Toepassing *toep in cat.toepassingen) {
            NSString *toepTitel = @"";
            NSString *toepTekst = @"";
            
            if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
                toepTitel = [toep.titelNL lowercaseString];
                toepTekst = [toep.omschrijvingNL lowercaseString];
            } else {
                toepTitel = [toep.titelFR lowercaseString];
                toepTekst = [toep.omschrijvingFR lowercaseString];
            }
            
            range2 = [toepTitel rangeOfString:searchVar];
            range3 = [toepTekst rangeOfString:searchVar];
            
            if (range2.location != NSNotFound || range3.location != NSNotFound) {
                toepFound = YES;
            }
        }
        
        if (range1.location != NSNotFound || toepFound) {
            [searchCategorieArray addObject:cat];
        }
    }
    
    if ([searchCategorieArray count]==0 && [searchTextFieldStart.text isEqualToString:@""]) {
        [self toonCategorieen:categorieArray searchNothingFound:YES];
        
        [UIView beginAnimations:nil context:nil];
        [UIView setAnimationDuration:0.3];
        geenResultaten.alpha = 0;
        [UIView commitAnimations];
    } else {
        [self toonCategorieen:searchCategorieArray searchNothingFound:NO];
        
        if ([searchCategorieArray count]==0) {
            for (ToepassingView *tp in [[toepassingScrollView.subviews copy] autorelease]) {
                if ([tp isKindOfClass:[ToepassingView class]]) {
                    [tp removeFromSuperview];
                }
            }
            
            [UIView beginAnimations:nil context:nil];
            [UIView setAnimationDuration:0.3];
            geenResultaten.alpha = 1;
            [UIView commitAnimations];
            
            if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
                categorieTitel.text = @"Geen categorieën en toepassingen gevonden";
            } else {
                categorieTitel.text = @"Pas de catégories et applications";
            }
        } else {
            [UIView beginAnimations:nil context:nil];
            [UIView setAnimationDuration:0.3];
            geenResultaten.alpha = 0;
            [UIView commitAnimations];
        }
    }
}

//Search start & exit
- (void)searchFieldStartBegin:(id)sender {
    search = YES;
}
- (void)searchFieldStartExit:(id)sender {
    search = NO;
}

//Set orientation: posities & achtergronden
- (void)setOrientation:(NSString *)orientation {
    if ([orientation isEqualToString:@"Portrait"]) {
        self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg-start-p.jpg"]];
        searchFieldStart.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"start-zoek-bg-p.jpg"]];
        
        categorieScrollView.frame = CGRectMake(90, 210, 588, 746);
        
        for (UIButton *btn in [[categorieScrollView.subviews copy] autorelease]) {
            if ([btn isKindOfClass:[UIButton class]]) {
                btn.frame = CGRectMake(btn.frame.origin.x, btn.frame.origin.y, 526, btn.frame.size.height);
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-notselected-p.png"] forState:UIControlStateNormal];
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-hl-p.png"] forState:UIControlStateHighlighted];
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-selected-p.png"] forState:UIControlStateDisabled];
                btn.enabled = YES;
            }
        }
        
        btnNL.frame = CGRectMake(581, 56, btnNL.frame.size.width, btnNL.frame.size.height);
        btnFR.frame = CGRectMake(634, 56, btnFR.frame.size.width, btnFR.frame.size.height);
        
        searchFieldStart.frame = CGRectMake(396, 148, 250, 41);
        startTitel.frame = CGRectMake(123, 159, startTitel.frame.size.width, startTitel.frame.size.height);
        logoImage.frame = CGRectMake(85, logoImage.frame.origin.y, logoImage.frame.size.width, logoImage.frame.size.height);
        geenResultaten.frame = CGRectMake(173, 377, 422, 51);
        moduleSwitch.frame = CGRectMake(296, 0, moduleSwitch.frame.size.width, moduleSwitch.frame.size.height);
        
        toepassingScrollView.hidden = YES;
        categorieTitel.hidden = YES;
        aantalToep.hidden = YES;
    } else {
        self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg-start-l.jpg"]];
        searchFieldStart.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"start-zoek-bg-l.jpg"]];
        categorieScrollView.frame = CGRectMake(11, 246, 423, 471);
        
        int i = 0;
        for (UIButton *btn in [[categorieScrollView.subviews copy] autorelease]) {
            if ([btn isKindOfClass:[UIButton class]]) {
                btn.frame = CGRectMake(btn.frame.origin.x, btn.frame.origin.y, 360, btn.frame.size.height);
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-notselected-l.png"] forState:UIControlStateNormal];
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-hl-l.png"] forState:UIControlStateHighlighted];
                [btn setBackgroundImage:[UIImage imageNamed:@"start-categorie-selected-l.png"] forState:UIControlStateDisabled];
                
                if (i==0) {
                    btn.enabled = NO;
                    [self toonToepassingenForCategorie:[categorieArray objectAtIndex:0]];
                } else {
                    btn.enabled = YES;
                }
                i++;
            }
        }
        
        btnNL.frame = CGRectMake(910, 54, btnNL.frame.size.width, btnNL.frame.size.height);
        btnFR.frame = CGRectMake(963, 54, btnFR.frame.size.width, btnFR.frame.size.height);
        
        searchFieldStart.frame = CGRectMake(42, 185, 360, 41);
        startTitel.frame = CGRectMake(43, 138, startTitel.frame.size.width, startTitel.frame.size.height);
        logoImage.frame = CGRectMake(8, logoImage.frame.origin.y, logoImage.frame.size.width, logoImage.frame.size.height);
        geenResultaten.frame = CGRectMake(31, 290, 383, 51);
        moduleSwitch.frame = CGRectMake(445, 0, moduleSwitch.frame.size.width, moduleSwitch.frame.size.height);
        
        toepassingScrollView.hidden = NO;
        categorieTitel.hidden = NO;
        aantalToep.hidden = NO;
    }
}

//Toepassingen weergeven adhv gekozen categorie (enkel in landscape mode)
- (void)toonToepassingenForCategorie:(ToepassingenCategorie *)chosenCategorie {
    self.currentCategorie = chosenCategorie;
    
    for (ToepassingenCategorie *cat in categorieArray) {
        if (cat == currentCategorie) {
            self.toepassingArray = [[cat.sortedToepassingen mutableCopy] autorelease];
        }
    }
    
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        categorieTitel.text = currentCategorie.titelNL;
        aantalToep.text = [NSString stringWithFormat:@"%i toepassingen",[currentCategorie.toepassingen count]];
    } else {
        categorieTitel.text = currentCategorie.titelFR;
        aantalToep.text = [NSString stringWithFormat:@"%i applications",[currentCategorie.toepassingen count]];
    }
    
    for (UIView *view in [[[toepassingScrollView subviews] copy] autorelease]) {
        if ([view isKindOfClass:[ToepassingView class]]) {
            [view removeFromSuperview];
        }
    }
    
    int counterX = 0;
    int counterY = 0;
    
    float paddingX = 6;
    int paddingY = 9;
    
    int width = 179;
    int height = 145;
    
    for (Toepassing *toep in toepassingArray) {
        ToepassingView *toepassingView = [[ToepassingView alloc] initWithFrame:CGRectMake(paddingX + counterX*(width+paddingX), paddingY + counterY*(height+paddingY), width, height)];
        toepassingView.delegateStart = self;
        toepassingView.toepassing = toep;
        
        [toepassingScrollView addSubview:toepassingView];
        [toepassingView release];
        
        counterX++;
        if (counterX>=3) {
            counterX=0;
            counterY++;
        }
    }
    
    float count = [toepassingArray count];
    count = ceil(count/3);
    toepassingScrollView.contentSize = CGSizeMake(toepassingScrollView.frame.size.width, count*(height+paddingY)+paddingY);
}

//Categorieen weergeven
- (void)toonCategorieen:(NSMutableArray *)arr searchNothingFound:(BOOL)nothingFound {
    for (UIButton *cat in [[categorieScrollView.subviews copy] autorelease]) {
        if ([cat isKindOfClass:[UIButton class]]) {
            [cat removeFromSuperview];
        }
    }
    
    int i = 0;
    int height = 63;
    int width = 526;
    int padding = 20;
    
    for (ToepassingenCategorie *cat in arr) {
        UIButton *btn = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
        [btn addTarget:self action:@selector(openCategorie:) forControlEvents:UIControlEventTouchUpInside];
        btn.frame = CGRectMake(31, 31+i*(padding+height), width, height);
        btn.titleLabel.textAlignment = UITextAlignmentLeft;
        btn.tag = i;
        
        if (i==0) {
            btn.enabled = NO;
        }
        
        UILabel *lblTitel = [[UILabel alloc] initWithFrame:CGRectMake(15, 12, 300, 20)];
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            lblTitel.text = [cat valueForKey:@"titelNL"];
            btn.userInteractionEnabled = YES;
        } else {
            lblTitel.text = [cat valueForKey:@"titelFR"];
        }
        
        lblTitel.textColor = [UIColor colorWithRed:0.211 green:0.371 blue:0.648 alpha:1];
        lblTitel.font = [UIFont boldSystemFontOfSize:17];
        lblTitel.backgroundColor = [UIColor clearColor];
        [btn addSubview:lblTitel];
        [lblTitel release];
        
        UILabel *lblToepassingen = [[UILabel alloc] initWithFrame:CGRectMake(15, 32, 300, 20)];
        if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
            lblToepassingen.text = [NSString stringWithFormat:@"%i toepassingen",[[cat valueForKey:@"toepassingen"] count]];
        } else {
            lblToepassingen.text = [NSString stringWithFormat:@"%i applications",[[cat valueForKey:@"toepassingen"] count]];
        }
        
        lblToepassingen.textColor = [UIColor colorWithRed:0.211 green:0.371 blue:0.648 alpha:1];
        lblToepassingen.font = [UIFont systemFontOfSize:12];
        lblToepassingen.backgroundColor = [UIColor clearColor];
        [btn addSubview:lblToepassingen];
        [lblToepassingen release];
        
        [categorieScrollView addSubview:btn];
        
        [btn release];
        
        i++;
    }
    
    categorieScrollView.contentSize = CGSizeMake(categorieScrollView.frame.size.width, 62+[arr count]*(padding+height)-padding);
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation)) {
        [self setOrientation:@"Portrait"];
    } else {
        [self setOrientation:@"Landscape"];
        [self toonToepassingenForCategorie:[self getCategorieForButton:nil OrCount:0]];
    }
}

//Verander taal: moduleswitch, categorieen opnieuw tonen, searchfieldHit
- (void)veranderTaal {
    [moduleSwitch changeLanguage];
    [self toonCategorieen:categorieArray searchNothingFound:NO];
    searchTextFieldStart.text = @"";
    if (search) {
        [self searchFieldStartHit:nil];
    }
}
- (IBAction)setNL:(id)sender {
    if (btnNL.enabled) {
        btnNL.enabled = NO;
        btnFR.enabled = YES;
        
        [Brain brain].currentLang = @"NL";
        searchTextFieldStart.placeholder = @"Zoeken...";
        startTitel.text = [NSString stringWithFormat:@"Toepassingmodule", [categorieArray count]];
        geenResultaten.text = @"De zoekbewerking heeft geen overeenkomstige categorieën opgeleverd.";
        
        [self veranderTaal];
    }
}
- (IBAction)setFR:(id)sender {
    if (btnFR.enabled) {
        btnNL.enabled = YES;
        btnFR.enabled = NO;
        
        [Brain brain].currentLang = @"FR";
        searchTextFieldStart.placeholder = @"Rechercher...";
        startTitel.text = [NSString stringWithFormat:@"Module d'application", [categorieArray count]];
        geenResultaten.text = @"La recherche n'a pas produit de catégories correspondantes.";
        
        [self veranderTaal];
    }
}

//StartView openen na kiezen toepassing
- (void)kiesToepassing:(Toepassing *)aToepassing {
    for (ToepassingView *tp in [[toepassingScrollView.subviews copy] autorelease]) {
        if ([tp isKindOfClass:[ToepassingView class]]) {
            tp.selected = NO;
        }
    }
    
    if (search) {
        [searchTextFieldStart resignFirstResponder];
    }
    
    StartView *sv =  [[StartView alloc] init];
    sv.delegate = self;
    sv.startCategorie = currentCategorie;
    sv.categorieArray = self.categorieArray;
    sv.toepassing = aToepassing;
    sv.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
    [self presentModalViewController:sv animated:YES];
    [sv release];
}

//Portrait: StartView openen met gekozen toepassing
//Landscape: toepassingen weergeven (ToepassingView's)
- (IBAction)openCategorie:(UIButton *)sender {
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation)) {
        if (search) {
            [searchTextFieldStart resignFirstResponder];
        }
        StartView *sv =  [[StartView alloc] init];
        sv.delegate = self;
        sv.startCategorie = [self getCategorieForButton:sender OrCount:0];
        sv.categorieArray = self.categorieArray;
        sv.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
        [self presentModalViewController:sv animated:YES];
        [sv release];
    } else {
        for (UIButton *btn in [[categorieScrollView.subviews copy] autorelease]) {
            if ([btn isKindOfClass:[UIButton class]]) {
                btn.enabled = YES;
            }
        }
        
        [self toonToepassingenForCategorie:[self getCategorieForButton:sender OrCount:0]];
        sender.enabled = NO;
    }
}

//Geopende StartView sluiten
- (void)dismissController:(StartView *)sv {
    [sv dismissModalViewControllerAnimated:YES];
    
    searchTextFieldStart.text = @"";
    for (ToepassingView *tp in [[toepassingScrollView.subviews copy] autorelease]) {
        if ([tp isKindOfClass:[ToepassingView class]]) {
            tp.selected = NO;
        }
    }
    
    for (ToepassingView *tp in [[sv.toepassingScrollView.subviews copy] autorelease]) {
        if ([tp isKindOfClass:[ToepassingView class]]) {
            tp.imageView.image = nil;
        }
    }
    
    for (UIImageView *image in [[sv.largeToepassing.stapScrollView.subviews copy] autorelease]) {
        if ([image isKindOfClass:[UIImageView class]]) {
            image.image = nil;
            [image removeFromSuperview];
        }
    }
}

//Load: init moduleSwitch, searchfield init, set orientation, set language
- (void)viewDidLoad {
    [super viewDidLoad];
    
    [moduleSwitch initWithIndex:0 animated:NO];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchFieldStartHit:) name:UITextFieldTextDidChangeNotification object:searchTextFieldStart];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchFieldStartBegin:) name:UITextFieldTextDidBeginEditingNotification object:searchTextFieldStart];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchFieldStartExit:) name:UITextFieldTextDidEndEditingNotification object:searchTextFieldStart];
    
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation)) {
        [self setOrientation:@"Portrait"];
    } else {
        [self setOrientation:@"Landscape"];
    }
    
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        [self setNL:nil];
    } else {
        [self setFR:nil];
    }
    
    NSError *error;
    if (![[GANTracker sharedTracker] trackPageview:[NSString stringWithFormat:@"/Categorieën %@",[Brain brain].currentLang] withError:&error]) {
        NSLog(@"GA Error Start.h: viewDidLoad");
    }
    [error release];
}

//View did appear: init moduleSwitch (is nodig als men terugkeert van Store Locator)
- (void)viewDidAppear:(BOOL)animated {
    [moduleSwitch initWithIndex:0 animated:NO];
}

//Delegate method
- (void)changeLanguage {
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        [self setNL:nil];
    } else {
        [self setFR:nil];
    }
}

//Rotate
- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration {
    if (UIInterfaceOrientationIsPortrait(toInterfaceOrientation)) {
        [self setOrientation:@"Portrait"];
    } else {
        [self setOrientation:@"Landscape"];
    }
    
    categorieScrollView.contentSize = CGSizeMake(categorieScrollView.frame.size.width, categorieScrollView.contentSize.height);
}
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}

- (void)viewDidUnload {
    [super viewDidUnload];
    
    btnNL = nil;
    btnFR = nil;
    searchTextFieldStart = nil;
    searchFieldStart = nil;
    categorieScrollView = nil;
    startTitel = nil;
    toepassingScrollView = nil;
    logoImage = nil;
    geenResultaten = nil;
    moduleSwitch = nil;
}
- (void)dealloc {
    [categorieArray release];
    [toepassingArray release];
    [searchCategorieArray release];
    [currentCategorie release];
    [managedObjectContext release];
    [super dealloc];
}

@end
