//
//  StartView.h
//  Gyproc
//
//  Created by Bert Carrein on 6/04/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import <UIKit/UIKit.h>

#import "ToepassingenCategorie.h"
#import "Toepassing.h"
#import "Stap.h"
#import "ToepassingView.h"
#import "CategorieSwitchView.h"
#import "LargeToepassingView.h"
#import "ToepassingDelegate.h"
#import "StartDelegate.h"
#import "GANTracker.h"
#import "LanguageDelegate.h"

//Controller 2e view toepassingmodule: de toepassing voor de geslecteerde categorie wordt weergegeven (Toepassing object)
//Bij aanklikken van een categorie wordt er een view weergegeven van het type LargeToepassing
//De view die zorgt voor de weergave van de categorieen is van het type CategorieSwitchView
//De views die de kleine weergave van elke toepassing controleert is van het type ToepassingView
@interface StartView : UIViewController <ToepassingDelegate> {
    NSString *previousSearchVar;
}

@property (nonatomic, retain) NSMutableArray *categorieArray;
@property (nonatomic, retain) NSMutableArray *toepassingArray;
@property (nonatomic, retain) NSMutableArray *searchToepassingArray;

@property (nonatomic, retain) id<StartDelegate, LanguageDelegate> delegate;

@property (nonatomic, retain) ToepassingenCategorie *startCategorie;
@property (nonatomic) BOOL search;

@property (nonatomic, retain) IBOutlet UIScrollView *toepassingScrollView;
@property (nonatomic, retain) IBOutlet CategorieSwitchView *categorieSwitch;
@property (nonatomic, retain) IBOutlet LargeToepassingView *largeToepassing;
@property (nonatomic, retain) IBOutlet UIView *searchField;
@property (nonatomic, retain) IBOutlet UITextField *searchTextField;
@property (nonatomic, retain) IBOutlet UIButton *btnNL;
@property (nonatomic, retain) IBOutlet UIButton *btnFR;
@property (nonatomic, retain) IBOutlet UIButton *logoImage;
@property (nonatomic, retain) IBOutlet UIImageView *logoPlaceholder;
@property (nonatomic, retain) IBOutlet UILabel *geenResultaten;

@property (nonatomic, retain) Toepassing *toepassing;
@property (nonatomic, readonly, retain) ToepassingenCategorie *currentCategorie;

- (void)reposition:(NSString *)orientation;
- (void)toonToepassingen:(ToepassingenCategorie *)categorie forToepassing:(Toepassing *)toepassing forOrientation:(NSString *)orientation justRotate:(BOOL)justRotate;
- (void)kiesToepassing:(Toepassing *)aToepassing forOrientation:(NSString *)orientation;
- (void)setOrientation:(NSString *)orientation;
- (IBAction)setNL:(id)sender;
- (IBAction)setFR:(id)sender;
- (IBAction)goBackHome;

@end
