//
//  StartView.m
//  Gyproc
//
//  Created by Bert Carrein on 6/04/11.
//  Copyright 2011 DMS. All rights reserved.
//

#import "StartView.h"
#import <QuartzCore/QuartzCore.h>
#import "Brain.h"


@implementation StartView

@synthesize categorieArray,toepassingArray;
@synthesize searchToepassingArray;
@synthesize delegate;
@synthesize geenResultaten;
@synthesize search;
@synthesize startCategorie;
@synthesize toepassingScrollView,categorieSwitch;
@synthesize toepassing;
@synthesize largeToepassing;
@synthesize searchField,searchTextField;
@synthesize logoImage;
@synthesize btnNL,btnFR;
@synthesize logoPlaceholder;
@synthesize currentCategorie;

//Terugkeren van FotoView
- (void)dismissFotoView:(UIViewController *)viewController {
    [viewController dismissModalViewControllerAnimated:YES];
}

//Foto van de stap tonen in fullscreen
- (void)presentFotoView:(UIViewController *)viewController {
    self.modalPresentationStyle = UIModalPresentationCurrentContext;
    viewController.modalTransitionStyle = UIModalTransitionStyleCrossDissolve;
    [self presentModalViewController:viewController animated:NO];
}

//Start video
- (void)speelVideo:(NSURL *)url {
    MPMoviePlayerViewController *mpvController = [[MPMoviePlayerViewController alloc] initWithContentURL:url];
    self.modalPresentationStyle = UIModalPresentationFullScreen;
    [self presentMoviePlayerViewControllerAnimated:mpvController];
    mpvController = nil;
    [mpvController release];
}

//Meer informatie over toepassing weergeven (titel, stappen...) adhv LargeToepassing View (aanwezig in xib file)
- (void)kiesToepassing:(Toepassing *)aToepassing forOrientation:(NSString *)orientation {
    if (aToepassing != nil) {
        if (search) {
            [searchTextField resignFirstResponder];
        }
        [largeToepassing showWhiteView];
        self.toepassing = aToepassing;
        if ([orientation isEqualToString:@"none"]) {
            if (UIInterfaceOrientationIsLandscape(self.interfaceOrientation)) {
                [largeToepassing initGUI:toepassing forOrientation:@"Landscape"];
            } else {
                [largeToepassing initGUI:toepassing forOrientation:@"Portrait"];
            }
        } else {
            [largeToepassing initGUI:toepassing forOrientation:orientation];
        }
    }
}

//Toepassingen tonen
- (void)toepassingenWeergeven:(NSMutableArray *)toepassingen forToepassing:(Toepassing *)aToepassing forOrientation:(NSString *)orientation justRotate:(BOOL)justRotate {
    int counterX = 0;
    int counterY = 0;
    
    float paddingX = 6;
    int paddingY;
    
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation) && [orientation isEqualToString:@"none"] || [orientation isEqualToString:@"Portrait"]) {
        paddingY = 10;
    } else {
        paddingY = 9;
    }
    
    int width = 179;
    int height = 145;
    
    [toepassingScrollView scrollRectToVisible:CGRectMake(0, 0, toepassingScrollView.frame.size.width, toepassingScrollView.frame.size.height) animated:NO];
    
    Toepassing *toep2 = nil;
    for (Toepassing *toep in toepassingen) {
        ToepassingView *toepassingView = [[ToepassingView alloc] initWithFrame:CGRectMake(paddingX + counterX*(width+paddingX), paddingY + counterY*(height+paddingY), width, height)];
        toepassingView.delegate = self;
        toepassingView.toepassing = toep;
        
        [toepassingScrollView addSubview:toepassingView];
        [toepassingView release];
        
        if (!search) {
            BOOL found = NO;
            if (aToepassing == toep) {
                toep2 = [toep retain];
                
                toepassingView.selected = YES;
                found = YES;
            }
            if (!aToepassing && !found && counterX == 0 && counterY == 0) {
                toep2 = [toep retain];
                toepassingView.selected = YES;
            }
        }
        
        if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation) && [orientation isEqualToString:@"none"] || [orientation isEqualToString:@"Portrait"]) {
            counterX++;
            counterY = 0;
        } else if (UIInterfaceOrientationIsLandscape(self.interfaceOrientation) && [orientation isEqualToString:@"none"] || [orientation isEqualToString:@"Landscape"]) {
            counterX++;
            if (counterX>=2) {
                counterX=0;
                counterY++;
            }
        }
    }
    
    if (justRotate) {
        toep2 = nil;
    }
    
    if (UIInterfaceOrientationIsPortrait(self.interfaceOrientation) && [orientation isEqualToString:@"none"] || [orientation isEqualToString:@"Portrait"]) {
        toepassingScrollView.contentSize = CGSizeMake([toepassingen count]*(width+paddingX)+paddingX, height);
        if (toep2) {
            [self kiesToepassing:toep2 forOrientation:@"Portrait"];
        }
    } else if (UIInterfaceOrientationIsLandscape(self.interfaceOrientation) && [orientation isEqualToString:@"none"] || [orientation isEqualToString:@"Landscape"]) {
        float count = [toepassingen count];
        count = ceil(count/2);
        toepassingScrollView.contentSize = CGSizeMake(toepassingScrollView.frame.size.width, count*(height+paddingY)+paddingY);
        if (toep2) {
            [self kiesToepassing:toep2 forOrientation:@"Landscape"];
        }
    }
    [toep2 release];
}

//Voorbereiding voordat toepassingen worden getoond
- (void)toonToepassingen:(ToepassingenCategorie *)categorie forToepassing:(Toepassing *)aToepassing forOrientation:(NSString *)orientation justRotate:(BOOL)justRotate {
    if (categorie != nil) {
        for (ToepassingenCategorie *cat in categorieArray) {
            if (cat == categorie) {
                self.toepassingArray = [[cat.sortedToepassingen mutableCopy] autorelease];
            }
        }
        for (UIView *view in [[toepassingScrollView.subviews copy] autorelease]) {
            if ([view isKindOfClass:[ToepassingView class]]) {
                [view removeFromSuperview];
            }
        }
        
        [self toepassingenWeergeven:toepassingArray forToepassing:aToepassing forOrientation:orientation justRotate:justRotate];
        searchTextField.text = @"";
    } else {
        for (UIView *view in [[toepassingScrollView.subviews copy] autorelease]) {
            if ([view isKindOfClass:[ToepassingView class]]) {
                [view removeFromSuperview];
            }
        }
        if (searchToepassingArray != nil) {
            [self toepassingenWeergeven:searchToepassingArray forToepassing:nil forOrientation:orientation justRotate:justRotate];
        }
    }
}

//Search
- (void)searchFieldStartViewHit:(id)sender {
    NSString *searchVar = searchTextField.text;
    
    for (UIView *view in [[toepassingScrollView.subviews copy] autorelease]) {
        if ([view isKindOfClass:[ToepassingView class]]) {
            [view removeFromSuperview];
        }
    }
        
    NSRange range1;
    NSRange range2;
    NSRange range3;
    [searchToepassingArray release];
    searchToepassingArray = [[NSMutableArray alloc] init];
    
    for (Toepassing *toep in toepassingArray) {
        BOOL toepFound = NO;
        NSString *toepTitel = @"";
        NSString *toepTekst = @"";
        
        if ([toep.stappen count]!=0) {
            for (Stap *stap in toep.stappen) {
                NSString *stapTekst;
                
                if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
                    stapTekst = [stap.tekstNL lowercaseString];
                    toepTitel = [stap.toepassing.titelNL lowercaseString];
                    toepTekst = [stap.toepassing.omschrijvingNL lowercaseString];
                } else {
                    stapTekst = [stap.tekstFR lowercaseString];
                    toepTitel = [stap.toepassing.titelFR lowercaseString];
                    toepTekst = [stap.toepassing.omschrijvingFR lowercaseString];
                }
                
                range1 = [stapTekst rangeOfString:[searchVar lowercaseString]];
                if (range1.location != NSNotFound) {
                    toepFound = YES;
                }
            }
        } else {
            if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
                toepTitel = [toep.titelNL lowercaseString];
                toepTekst = [toep.omschrijvingNL lowercaseString];
            } else {
                toepTitel = [toep.titelFR lowercaseString];
                toepTekst = [toep.omschrijvingFR lowercaseString];
            }
        }
        
        range2 = [toepTitel rangeOfString:[searchVar lowercaseString]];
        range3 = [toepTekst rangeOfString:[searchVar lowercaseString]];
        if (range2.location != NSNotFound || range3.location != NSNotFound || toepFound) {
            [searchToepassingArray addObject:toep];
        }
    }
        
    if ([searchToepassingArray count]==0 && [searchTextField.text isEqualToString:@""]) {
        [self toepassingenWeergeven:toepassingArray forToepassing:nil forOrientation:@"none" justRotate:NO];
        
        [UIView beginAnimations:nil context:nil];
        [UIView setAnimationDuration:0.3];
        geenResultaten.alpha = 0;
        [UIView commitAnimations];
    } else {
        [self toepassingenWeergeven:searchToepassingArray forToepassing:nil forOrientation:@"none" justRotate:NO];
        
        if ([searchToepassingArray count]==0) {
            [UIView beginAnimations:nil context:nil];
            [UIView setAnimationDuration:0.3];
            geenResultaten.alpha = 1;
            [UIView commitAnimations];
        } else {
            [UIView beginAnimations:nil context:nil];
            [UIView setAnimationDuration:0.3];
            geenResultaten.alpha = 0;
            [UIView commitAnimations];
        }
    }
}

//Search begin & exit
- (void)searchFieldStartViewBegin:(id)sender {
    search = YES;
    [self searchFieldStartViewHit:nil];
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.5];
    largeToepassing.alpha = 0;
    logoPlaceholder.alpha = 1;
    [UIView commitAnimations];
}
- (void)searchFieldStartViewExit:(id)sender {
    search = NO;
    BOOL found = NO;
    for (ToepassingView *tp in [[toepassingScrollView.subviews copy] autorelease]) {
        if ([tp isKindOfClass:[ToepassingView class]]) {
            if (tp.selected) {
                [self kiesToepassing:tp.toepassing forOrientation:@"none"];
                found = YES;
            }
        }
    }
    
    if (!found) {
        int i=0;
        for (ToepassingView *tp in [[toepassingScrollView.subviews copy] autorelease]) {
            if ([tp isKindOfClass:[ToepassingView class]]) {
                if (i==0) {
                    tp.selected = YES;
                    [self kiesToepassing:tp.toepassing forOrientation:@"none"];
                }
                i++;
            }
        }
    }
    
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:0.4];
    logoPlaceholder.alpha = 0;
    [UIView commitAnimations];
}

//Load: init categorieSwitch, init search, set talen
- (void)viewDidLoad {
    [super viewDidLoad];
    
    largeToepassing.delegate = self;
    categorieSwitch.delegate = self;
    [categorieSwitch initCategorieSwitch:categorieArray forStartCategorie:self.startCategorie forToepassing:toepassing];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchFieldStartViewHit:) name:UITextFieldTextDidChangeNotification object:searchTextField];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchFieldStartViewBegin:) name:UITextFieldTextDidBeginEditingNotification object:searchTextField];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchFieldStartViewExit:) name:UITextFieldTextDidEndEditingNotification object:searchTextField];
    
    if ([[Brain brain].currentLang isEqualToString:@"NL"]) {
        btnNL.enabled = NO;
        btnFR.enabled = YES;
        searchTextField.placeholder = @"Zoek in toepassingen...";
        geenResultaten.text = @"De zoekbewerking heeft geen overeenkomstige toepassingen opgeleverd.";
    } else  {
        btnNL.enabled = YES;
        btnFR.enabled = NO;
        searchTextField.placeholder = @"Recherchez les applications...";
        geenResultaten.text = @"La recherche n'a pas produit d'applications correspondantes.";
    }
    
    NSError *error;
    if (![[GANTracker sharedTracker] trackPageview:[NSString stringWithFormat:@"/%@/Toepassingen %@",categorieSwitch.currentCategorie.titelNL,[Brain brain].currentLang] withError:&error]) {
        NSLog(@"GA Error StartView.h: viewDidLoad");
    }
    [error release];
}

//Set orientation: backgrounds
- (void)setOrientation:(NSString *)orientation {
    if ([orientation isEqualToString:@"Portrait"]) {
        self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg-p.jpg"]];
        categorieSwitch.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"categorie-zoek-bg-p.jpg"]];
        searchField.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"categorie-zoek-bg-p.jpg"]];
    } else {
        self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg-l.jpg"]];
        categorieSwitch.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"categorie-zoek-bg-p.jpg"]];
        searchField.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"categorie-zoek-bg-p.jpg"]];
    }
}

//Alle controls herpositioneren
- (void)reposition:(NSString *)orientation {
    int stap = largeToepassing.currentStap;
    
    if ([orientation isEqualToString:@"Landscape"]) {
        searchField.frame = CGRectMake(18, 185, 363, 41);
        categorieSwitch.frame = CGRectMake(18, 136, 363, 41);
        toepassingScrollView.frame = CGRectMake(10.5, 246, 377, 471);
        logoImage.frame = CGRectMake(logoImage.frame.origin.x, 13, logoImage.frame.size.width, logoImage.frame.size.height);
        logoPlaceholder.frame = CGRectMake(500, 200, logoPlaceholder.frame.size.width, logoPlaceholder.frame.size.height);
        geenResultaten.frame = CGRectMake(30, 285, 357, 70);
        
        btnNL.frame = CGRectMake(btnNL.frame.origin.x , 54, btnNL.frame.size.width, btnNL.frame.size.height);
        btnFR.frame = CGRectMake(btnFR.frame.origin.x, 54, btnFR.frame.size.width, btnFR.frame.size.height);
    } else {
        searchField.frame = CGRectMake(387, 135, 363, 41);
        categorieSwitch.frame = CGRectMake(18, 135, 363, 41);
        toepassingScrollView.frame = CGRectMake(10, 189, 748, 165);
        logoImage.frame = CGRectMake(logoImage.frame.origin.x, 11, logoImage.frame.size.width, logoImage.frame.size.height);
        logoPlaceholder.frame = CGRectMake(195, 480, logoPlaceholder.frame.size.width, logoPlaceholder.frame.size.height);
        geenResultaten.frame = CGRectMake(170, 246, 427, 51);
        
        btnNL.frame = CGRectMake(btnNL.frame.origin.x ,50, btnNL.frame.size.width, btnNL.frame.size.height);
        btnFR.frame = CGRectMake(btnFR.frame.origin.x, 50, btnFR.frame.size.width, btnFR.frame.size.height);
    }
    
    if (search) {
        [self toonToepassingen:nil forToepassing:nil forOrientation:orientation justRotate:YES];
    } else {
        [self toonToepassingen:[categorieArray objectAtIndex:categorieSwitch.currentIndex] forToepassing:toepassing forOrientation:orientation justRotate:YES];
    }
    
    [self setOrientation:orientation];
    
    [largeToepassing changeOrientation:orientation];
    [largeToepassing setStapForTag:stap animated:YES];
}

//Rotate
- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration {
    if (toInterfaceOrientation == UIInterfaceOrientationLandscapeLeft || toInterfaceOrientation == UIInterfaceOrientationLandscapeRight) {
        [self reposition:@"Landscape"];
    } else {
        [self reposition:@"Portrait"];
    }
}
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}

//Verander taal: categorieSwitch + Start Controller
- (void)veranderTaal {
    [delegate changeLanguage];
    [categorieSwitch initCategorieSwitch:categorieArray forStartCategorie:categorieSwitch.currentCategorie forToepassing:largeToepassing.toepassing];
}
- (IBAction)setNL:(id)sender {
    if (btnNL.enabled) {
        btnNL.enabled = NO;
        btnFR.enabled = YES;
        
        [Brain brain].currentLang = @"NL";
        searchTextField.placeholder = @"Zoek in toepassingen...";
        geenResultaten.text = @"De zoekbewerking heeft geen overeenkomstige toepassingen opgeleverd.";
        
        [self veranderTaal];
    }
}
- (IBAction)setFR:(id)sender {
    if (btnFR.enabled) {
        btnNL.enabled = YES;
        btnFR.enabled = NO;
        
        [Brain brain].currentLang = @"FR";
        searchTextField.placeholder = @"Recherchez les applications...";
        geenResultaten.text = @"La recherche n'a pas produit d'applications correspondantes.";
        
        [self veranderTaal];
    }
}

//Terugkeren naar Start Controller
- (IBAction)goBackHome {
    
    self.categorieSwitch.currentCategorie = nil;
    self.toepassing = nil;
    
    [self.delegate dismissController:self];
}

- (ToepassingenCategorie *)currentCategorie {
    return categorieSwitch.currentCategorie;
}
- (void)viewDidUnload {
    [super viewDidUnload];
    self.toepassingScrollView = nil;
    self.categorieSwitch = nil;
    
    self.largeToepassing.stapScrollView = nil;
    self.largeToepassing.toepassingTitel = nil;
    
    self.largeToepassing = nil;
    self.searchTextField = nil;
    self.searchField = nil;
    self.btnFR = nil;
    self.btnNL = nil;
    self.logoImage = nil;
    self.logoPlaceholder = nil;
    self.geenResultaten = nil;
}
- (void)dealloc {
    [toepassing release];
    [currentCategorie release];
    [categorieArray release];
    [toepassingArray release];
    [searchToepassingArray release];
    [delegate release];
    [toepassingScrollView release];
    
    [super dealloc];
}

@end
